#ifndef _CADVANCEDIP_H_
#define _CADVANCEDIP_H_

#include "CBasicIP.h"
#include "CRectangle.h"

class CAdvancedIP : public CBasicIP
{
public:
  CAdvancedIP(CKnowledge* const k, CLogFile* const logfile);
  CAdvancedIP(const CAdvancedIP&);
  //virtual ~CAdvancedIP();

  bool PlayerCloserToBallAndBehindBall(const int_type hist) const;
  bool ClosestToBall(const int_type hist = CURRENT_EST) const;
  CPlayerObject* GetClosestTeammate(const int_type hist);
  CPlayerObject* GetClosestOpponent(const int_type hist);
  CPlayerObject* GetClosestPlayer(const int_type hist);
  float_type DistToClosestTeammate(const int_type hist = CURRENT_EST) const;
  float_type DistToClosestOpponent(const int_type hist) const;
  bool ClosestTeammateInfront(const int_type hist = CURRENT_EST);
  float_type DistToClosestOpponentInFront(const int_type hist = CURRENT_EST) const;

  float_type DistToLastPlayer(const int_type hist) const;
  float_type DistToLastOpponent(const int_type hist = CURRENT_EST) const;
  CVector GetObstacleVector(const int_type hist = CURRENT_EST) const;
  bool ObstacleOnVector(const CVector& v, const int_type hist = CURRENT_EST) const;
  CPoint GetAvoidObstaclePoint(const int_type hist = CURRENT_EST) const;

  bool BallOnSameSideAs(const CPoint& pt, const int_type hist) const;
  bool BallOnOtherSideOf(const CPoint& pt, const int_type hist = CURRENT_EST) const;
  
  bool BallKickable(const int_type hist = CURRENT_EST) const;
  bool BallInOurPenaltyArea(const int_type hist = CURRENT_EST) const;
  bool BallCatchable(const int_type hist = CURRENT_EST) const;
  bool BeforeKickOff(const int_type hist = CURRENT_EST) const;
  bool PossibleToScore(const int_type hist = CURRENT_EST) const;
  bool GoodForwardPass(const int_type hist = CURRENT_EST) const;
  bool GoodGoaliePass(const int_type hist) const;
  bool GoodDefenderPass(const int_type hist) const;
  bool GoodBackwardPass(const int_type hist = CURRENT_EST) const;
  bool GoodCornerPass(const int_type hist = CURRENT_EST) const;
  bool CloseToBall(const int_type hist = CURRENT_EST) const;
  bool BallPrettyClose(const int_type hist = CURRENT_EST) const;
  bool BehindBall(const int_type hist = CURRENT_EST) const;
  bool OurTeamAttacking(const int_type hist = CURRENT_EST) const;
  bool TheirTeamAttacking(const int_type hist = CURRENT_EST) const;
  bool BallOnLeftSide(const int_type hist = CURRENT_EST) const;
  bool BallOnRightSide(const int_type hist = CURRENT_EST) const;
  bool BallOnOurSide(const int_type hist = CURRENT_EST) const;
  bool BallOnTheirSide(const int_type hist = CURRENT_EST) const;
  bool Sparse(const CRectangle& rect, const int_type hist) const;
  bool SparseCenter(const int_type hist = CURRENT_EST) const;

  bool LeftCornerKick(const int_type hist) const;
  bool RightCornerKick(const int_type hist) const;
  
protected:
  
private:
  // So the compiler won't generate an assignment operator.
  CAdvancedIP& operator =(const CAdvancedIP&);
};
  
#endif
