#include "CAngleDeg.h"

// CAngleDeg -------------------------------------------------------------------

// --- public constructor -----------------------------------------------------
CAngleDeg::CAngleDeg(float_type d)
  : a(d)
{
  _normalize();
}

// --- public copy constructor ------------------------------------------------
CAngleDeg::CAngleDeg(const CAngleDeg& ang)
  : a(ang.a)
{
}

// --- public conversion constructor ------------------------------------------
CAngleDeg::CAngleDeg(const CAngleRad& ang)
  : a(ang.GetDeg())
{
}

// --- public -----------------------------------------------------------------
// assign, no range check
CAngleDeg& CAngleDeg::operator =(const CAngleRad& ang)
{
  a = ang.GetDeg();
  return *this;
}

// --- protected --------------------------------------------------------------
void CAngleDeg::_normalize()
{
  // Equal to:
  //a = Mod((a + 180), 360.0) - 180;
  // don't know which is more efficient...
  while (a <= -180) a += 360;
  while (a >   180) a -= 360;
}
