#include "CAngleRad.h"

// CAngleRad -------------------------------------------------------------------
// --- public constructor -----------------------------------------------------
CAngleRad::CAngleRad(const float_type d)
  : a(d)
{
  _normalize();
}

// --- public copy constructor ------------------------------------------------
CAngleRad::CAngleRad(const CAngleRad& ang)
  : a(ang.a)
{
}

// --- public conversion constructor ------------------------------------------
CAngleRad::CAngleRad(const CAngleDeg& ang)
  : a(ang.GetRad())
{
}

// --- public -----------------------------------------------------------------
// assign, no range check
CAngleRad& CAngleRad::operator =(const CAngleDeg& ang)
{
  a = ang.GetRad();
  return *this;
}

// --- protected --------------------------------------------------------------
void CAngleRad::_normalize()
{
  while (a <= -m_pi) a += m_two_pi;
  while (a > m_pi) a -= m_two_pi;
}

