#ifndef _CBALLOBJECT_H_
#define _CBALLOBJECT_H_

#include "types.h"
#include "CMobileObject.h"
#include "CParameters.h"

class CBallObject : public CMobileObject
{
public:
  CBallObject(const CParameters* const p,
	      const int_type hist_length = DEFAULT_HIST_LENGTH);
  CBallObject(const CBallObject& obj);

  CBallObject& operator= (const CBallObject& obj);

  void ResetAll();
  void Reset();

  void SetRelativeBallPos(const CVector& vec);
  CVector GetRelativeBallPos() const;

  void SetLastSeenMovingTime(const CTime& tm);
  CTime GetLastSeenMovingTime() const;
  
  // Redefined since we now have access to the player_speed_max parameter.
  void SetAbsoluteSpeedVector(const CVector& v, const int_type hist = NEXT);
  void SetSpeed(const t_speed& speed, const int_type hist = NEXT);
  
protected:
  const CParameters* params;
  bool have_parameters;

  CVector relative_ball_pos;
  static const CVector DEFAULT_RELATIVE_BALL_POS;

  CTime last_seen_moving_time;
  static const CTime DEFAULT_LAST_SEEN_MOVING_TIME;
  
  void CopyData(const CBallObject& obj);
  
};

inline void CBallObject::SetRelativeBallPos(const CVector& vec)
{
  relative_ball_pos = vec;
}

inline CVector CBallObject::GetRelativeBallPos() const
{
  return relative_ball_pos;
}

inline void CBallObject::SetLastSeenMovingTime(const CTime& tm)
{
  last_seen_moving_time = tm;
}

inline CTime CBallObject::GetLastSeenMovingTime() const
{
  return last_seen_moving_time;
}
  
#endif
