#include "CCommand.h"
#include "CKnowledge.h"

CCommand::CCommand(CKnowledge* const kb, const t_cmd_type c_type,
		   const t_priority prio,
		   const CTime& s_time, const CTime& f_time)
  : k(kb),
    cmd_type(c_type),
    cmd_priority(prio),
    start_time(s_time),
    finish_time(f_time)
{
}

CCommand::CCommand(const CCommand& obj)
  : k(obj.k),
    cmd_type(obj.cmd_type),
    cmd_priority(obj.cmd_priority),
    start_time(obj.start_time),
    finish_time(obj.finish_time)
{
}

CCommand::~CCommand()
{

}

void CCommand::CopyCommand(const CCommand& obj)
{
  k = obj.k;
  cmd_type = obj.cmd_type;
  cmd_priority = obj.cmd_priority;
  start_time = obj.start_time;
  finish_time = obj.finish_time;
}

CCommand& CCommand::operator =(const CCommand& obj)
{
  if ( this != &obj ) {
    CopyCommand(obj);
  }

  return *this;
}

void CCommand::Error() const
{
  std::cout << "Error! Not correct command type!";
  exit(1);
}  
