#ifndef _CCOMMAND_QUEUE_H_
#define _CCOMMAND_QUEUE_H_

#include <queue>
#include "CCommand.h"
#include "CPlan.h"

class CCommandQueue
{
public:
  CCommandQueue();
  CCommandQueue(const CPlan&);
  CCommandQueue(const CCommandQueue&);
  ~CCommandQueue();

  CCommandQueue& operator =(const CCommandQueue&);
  CCommandQueue& operator =(const CPlan&);

  CCommandQueue  operator+ (const CCommandQueue&) const;
  CCommandQueue  operator+ (const CPlan&)         const;
  CCommandQueue  operator+ (CCommand* const)      const;
  CCommandQueue& operator+=(const CCommandQueue&);
  CCommandQueue& operator+=(const CPlan&);
  CCommandQueue& operator+=(CCommand* const);

  void Push(const CCommandQueue&);
  void Push(const CPlan&);
  void Push(CCommand* const);
  
  const CCommand* const Top();
  const CCommand* const Top() const;
  void  Remove(const int);
  void  Pop();

  void MakeEmpty();
  bool Empty() const;
  int  Length() const;

private:
  std::queue<CCommand*> commands;

};

inline bool CCommandQueue::Empty() const
{
  return commands.empty();
}

inline int CCommandQueue::Length() const
{
  return commands.size();
}

#endif
