#include "CConfidence.h"

// Set the default values for min and max confidence.
float CConfidence::max_conf_default = 1.0;
float CConfidence::min_conf_default = 0.0;

CConfidence::CConfidence(const float c, const float min_c, const float max_c)
  : min_conf(min_c),
    max_conf(Max(max_c, min_conf)),
    confidence(MinMax(min_conf, c, max_conf))
{
}

CConfidence::CConfidence(const CConfidence& c)
  : min_conf(c.min_conf),
    max_conf(c.max_conf),
    confidence(c.confidence)
{
}
