#include "CCustomCommand.h"
#include "utils.h"

CCustomCommand::CCustomCommand(CKnowledge* const kb,
			       const t_custom_command_type type, const int m,
			       const t_priority prio, const CTime& s_time,
			       const CTime& f_time)
  : CCommand(kb, CMD_Custom, prio, s_time, f_time),
    custom_command_type(type),
    mode(m)
{
}

CCustomCommand::CCustomCommand(const CCustomCommand& obj)
  : CCommand(obj),
    custom_command_type(obj.custom_command_type),
    mode(obj.mode),
    vec(obj.vec),
    pt(obj.pt)
{
}

CCustomCommand::~CCustomCommand()
{
}

void CCustomCommand::CopyCommand(const CCustomCommand& obj)
{
  CCommand::CopyCommand(obj);
  custom_command_type = obj.custom_command_type;
  mode = obj.mode;
  vec = obj.vec;
  pt = obj.pt;
}

CCustomCommand& CCustomCommand::operator =(const CCustomCommand& obj)
{
  if ( this != &obj ) {
    CopyCommand(obj);
  }

  return *this;
}

void CCustomCommand::UpdateAfterCommand(const int_type from,
					const int_type to) const
{
}

bool CCustomCommand::Validate(const int_type hist)
{
  return false;
}
  
const std::string CCustomCommand::ServerString() const
{
  return ("Custom command type: " + ToString(custom_command_type) + " mode: "
	  + ToString(mode));
}


