#include "CDecision.h"

CDecision::CDecision(CFCFooIP* const f_ip)
  : ip(f_ip),
    k(ip->GetKnowledge()),
    p(k->GetParameters())
{
  test = false;
  test1 = false;
  testSensors = false;
}

/*
CDecision::~CDecision()
{
}
*/

CCommand* CDecision::Decide()
{

  static bool moved = false;
  
  const int_type hist = CURRENT_EST;
  
  t_dt_type current_dt = ip->GetDT();
  CCommand* next_cmd = NULL;

  /*
  if ( current_dt == DT_MyFreeKick )
    std::cout << "Player number " << k->theAgent().GetUNumber()
	      << " will take the free kick!\n";      
	      */
  
  if ( testSensors ) {
    if ( ( k->theAgent().GetUNumber() % 2 ) == 0 ) {
      if ( k->theBall().GetConfidence(hist) < p->RS_low_confidence ) {
	next_cmd = new CCustomCommand(k, CCMD_FindBall);
      } else if ( ip->BallKickable(hist) ) {
	//	     && ip->BehindBall(hist) ) {
	if ( ip->PossibleToScore(hist) ) {
	  next_cmd = new CCustomCommand(k, CCMD_Score);
	} else  {//if ( ip->DistToClosestOpponentInFront(hist) > 10 ) {
	  next_cmd = new CCustomCommand(k, CCMD_Dribble, 1);
	}
      } else {
	//	next_cmd = new CCustomCommand(k, CCMD_InterceptBall);
	next_cmd = new CCustomCommand(k, CCMD_MoveTo, 1);
      }
    } else {
      next_cmd = new CCustomCommand(k, CCMD_TrackBall);
    }
  } else {

    if ( test ) {

      /*
	bool BallInOurPenaltyArea();
	bool BallCatchable();
	bool BallInMyHomeArea();
	bool OpponentInMyArea();
	bool BeforeKickOff();
	bool PossibleToScore();
	bool GoodForwardPass();
	bool GoodBackwardPass();
	bool CloseToBall();
	bool BallPrettyClose();
	bool BehindBall();
	bool OurTeamAttacking();
	bool TheirTeamAttacking();
	bool BallOnOurSide();
	bool OuterPlayer();
	bool InnerPlayer();
	bool PlayOnLeftSide();
	bool PlayOnRightSide();
	bool PlayInCenter();
	bool SparseMySide();
	bool SparseCenter();
	bool GoalKeeper();
	bool Defender();
	bool Midfielder();
	bool OuterMidfielder();
	bool InnerMidfielder();
	bool Attacker();
	*/
    
      std::cout //<< "BallKickable = " << ip->BallKickable(hist)
	//	 << "\tBehindBall = " << ip->BehindBall(hist)
	<< "\tClosestToBall = " << ip->ClosestToBall(hist)
	//<< "\tObstacleOnVector = " << ip->ObstacleOnVector(k->theBall().GetVector(hist))
	//	 << "\tPossibleToScore = " << ip->PossibleToScore(hist)
	<< "\tGoodForwardPass = " << ip->GoodForwardPass(hist)
	<< "\tGoodBackwardPass = " << ip->GoodBackwardPass(hist)
	<< std::endl;
    
    }

    // All I should do here is to dispatch the work to a suitable decide-method!

    if ( current_dt == DT_BeforeKickOff ) {
      //std::cout << "Before kickoff!" << std::endl;
      //    if ( k->theAgent().GetPosition() == ip->GetRole()->GetHomePosition() ) {
      //      next_cmd = new CCustomCommand(k, CCMD_TrackBall);
      //    } else {
      if ( k->theAgent().GetDistanceTo(ip->GetRole()->GetInitPosition(), hist) < 2
	   && moved ) {
	/*
	if ( k->theGame().GetKickOffMode() == KO_Ours ) {
	  ip->SetDT(DT_OurKickOff);
	  return Decide();
	} else {
	  ip->SetDT(DT_TheirKickOff);
	  return Decide();
	}
	*/
	//if ( Abs(k->theAgent().GetRelativeDirectionTo(CPoint(0,0), hist)) > 4 )
	next_cmd = new CTurnCommand(k, CPoint(0,0));
	//else
	//next_cmd = new CCustomCommand(k, CCMD_TrackBall);
      } else {
	next_cmd = new CMoveCommand(k, ip->GetRole()->GetInitPosition());
	moved = true;
      //std::cout << "Sent a move command point = " << ip->GetRole()->GetHomePosition()
      //	<< std::endl;
      }
    } else {
      moved = false;
      if (ip->GoalKeeper()) {
	if ( test1 ) std::cout << "GoalKeeper. " << std::endl;
	next_cmd = DecideGoalKeeper();
      } else if (ip->Defender()) {
	if ( test1 ) std::cout << "Defender. " << std::endl;
	next_cmd = DecideDefender();
      } else if (ip->Midfielder()) {
	if ( test1 ) std::cout << "Midfielder. " << std::endl;
	next_cmd = DecideMidfielder();
      } else if (ip->Attacker()) {
	if ( test1 ) std::cout << "Attacker. " << std::endl;
	next_cmd = DecideAttacker();
      } else {
	std::cout << "[Decide] Problems with the role!" << std::endl;
      }
    }
  }

  return next_cmd;
  
}

CCommand* CDecision::DecideGoalKeeper()
{

  const int_type hist = CURRENT_EST;

  CCommand* nxt_cmd = NULL;
  CCustomCommand* cmd = NULL;
  t_dt_type dt = ip->GetDT();
  static bool moving = false;

  //  std::cout << "Current playmode: " << k->theGame().GetPlayMode()
  // << " current DT: " << dt << std::cout;

  /*
  std::cout << "My pos: " << k->theAgent().GetPosition(hist)
	    << " ball pos: " << k->theBall().GetPosition(hist)
	    << " ball vec: " << k->theBall().GetVector(hist)
	    << std::endl;
	    */
  
  if ( dt == DT_OurGoalieGotBall ) {
    if ( k->theAgent().GetDistanceTo(ip->GoalieCatchPoint(hist), hist) > 4 )
      nxt_cmd = new CMoveCommand(k, ip->GoalieCatchPoint(hist));
    else if ( k->theBall().GetDirection(hist) < p->RS_max_dev_ball_dir ) {
      if ( ip->GoodGoaliePass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 1);
      } else {
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else {
      nxt_cmd = new CTurnCommand(k, k->theBall().GetDirection(hist));
    }
  } else if ( k->theBall().GetConfidence(hist) < p->RS_medium_confidence ) {
    cmd = new CCustomCommand(k, CCMD_FindBall);
  } else if (dt == DT_Normal ||
	     dt == DT_TheirKickOff ||
	     dt == DT_OurKickOff ||	     
	     dt == DT_TheirFreeKick ||
	     dt == DT_OurFreeKick ) {
    if ( ip->BallCatchable(hist) ) {
      cmd = new CCustomCommand(k, CCMD_Catch);
      //    } else if ( k->theBall().GetConfidence(hist) < p->RS_high_confidence ) {
      //      cmd = new CCustomCommand(k, CCMD_FindBall);
    } else if ( ip->BallInOurPenaltyArea(hist) &&
		( k->theBall().GetDistance(hist) < 15 ||
		  k->theBall().GetPosX(hist) < -50 ||
		  2*k->theBall().GetDistance(hist) <
		  ip->DistToClosestOpponent(hist) ) ) {
      //      && ip->ClosestToBall(hist) ) {
      cmd = new CCustomCommand(k, CCMD_Rush);
      //cmd = new CCustomCommand(k, CCMD_InterceptBall);
    } else if ( k->theAgent().GetDistanceTo(ip->GoaliePos(hist), hist) > 2 ) {
      //      && !ip->CloseToBall(hist) ) {
      moving = true;
      /*
      if ( ip->BallOnSameSideAs(ip->GoaliePos(hist), hist) ) {
	cmd = new CCustomCommand(k, CCMD_MoveTo);
	cmd->SetPoint(ip->GoaliePos(hist));
      } else {
      */
      cmd = new CCustomCommand(k, CCMD_GoalieMoveTo);
      cmd->SetPoint(ip->GoaliePos(hist));
      //}
    } else {
      cmd = new CCustomCommand(k, CCMD_TrackBall);
    }
  } else if (dt == DT_MyFreeKick) {
    //    std::cout << "In My FreeKick!" << std::endl;    
    if ( ip->BallCatchable(hist) ) {
      cmd = new CCustomCommand(k, CCMD_Catch);
    } else {
      cmd = new CCustomCommand(k, CCMD_MoveTo, 1);
    }
    /*
    if ( //ip->BehindBall(hist) &&
	 ip->BallKickable(hist) ) {
      if ( ip->GoodGoaliePass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 1);
      } else {
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_GetBehindBall);
    }
    */
  }

  if ( nxt_cmd == NULL )
    nxt_cmd = cmd;
  else
    delete cmd;
  
  return nxt_cmd;
    
}

CCommand* CDecision::DecideDefender()
{

  static bool ignore_ball = false;
  
  const int_type hist = CURRENT_EST;

  CCustomCommand* cmd = NULL;
  t_dt_type dt = ip->GetDT();

  if ( !ignore_ball &&
       k->theBall().GetConfidence(hist) < p->RS_medium_confidence ) {
    cmd = new CCustomCommand(k, CCMD_FindBall);
  } else if ( dt == DT_MyFreeKick) {
    //    std::cout << "In Defender::MyFreeKick!" << std::endl;
    if ( //ip->BehindBall(hist) &&
	 ip->BallKickable(hist) ) {
      if ( ip->GoodDefenderPass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 2);
      } else {
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_GetBehindBall);
    }
  } else if ( dt == DT_OurFreeKick && k->theBall().GetPosX() < -20 ) {
    cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
    if ( ip->PlayOnLeftSide() )
      cmd->SetVector(CVector(45, 10));
    else
      cmd->SetVector(CVector(-45, 10));
    //cmd = new CCustomCommand(k, CCMD_MakePassable);
  } else if ( dt == DT_TheirFreeKick ||
	      dt == DT_TheirKickOff ) {
    if ( ip->DistToHomePos(hist) > 2 ) {
      cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
      cmd->SetPoint(ip->GetRole()->GetHomePosition());
    } else {
      cmd = new CCustomCommand(k, CCMD_TrackBall);
    }    
    //  } else if (dt == DT_TheirKickOff) {
    //    cmd = new CCustomCommand(k, CCMD_TrackBall);
  } else { //if (dt == DT_Normal ||
    //    dt == DT_OurKickOff ||
    //    dt == DT_TheirFreeKick ) {
    if ( ip->BallKickable(hist) ) {
      //	     && ip->BehindBall(hist) ) {
      if ( ip->PossibleToScore(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Score);
      } else if ( ip->GoodDefenderPass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 2);
      } else if ( ip->DistToClosestOpponentInFront(hist) > 10 ) {
	cmd = new CCustomCommand(k, CCMD_Dribble, 1);
      } else {
	//std::cout << "ClearBall by defender!" << std::endl;
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else if ( k->theAgent().GetPosX(hist) > (k->theBall().GetPosX(hist)-1) ) {
      // Get behind the ball, FAST!
      cmd = new CCustomCommand(k, CCMD_CutOffGoalAngle);
      //ip->ClosestToBall(NOW) || 
      //ip->BallInMyHomeArea(hist) ) {
      //( Abs(k->theAgent().GetPosY(hist)) > Abs(k->theBall().GetPosY(hist)) && 
      //	  k->theBall().GetPosX(hist) > k->theAgent().GetPosX(hist) ) ) {
      //cmd = new CCustomCommand(k, CCMD_InterceptBall);
      /*
    } else if ( ip->ClosestToBall(NOW) || 
		ip->BallInMyHomeArea(hist) ) {
	       //ip->BallInMyHomeArea(hist) ||
	       //k->theBall().GetPosX(hist) < k->theAgent().GetPosX(hist) ) {
      cmd = new CCustomCommand(k, CCMD_CutOffGoalAngle);
      */
    } else if ( ip->ClosestToBall(NOW) || 
		( ip->BallInMyHomeArea(hist) &&
		  !ip->PlayerCloserToBallAndBehindBall(hist)) ) {
      //&& ip->OnOurHalf(hist) ) {
      //	 && ip->BehindBall(hist) ) {
      cmd = new CCustomCommand(k, CCMD_InterceptBall);
    } else if ( ip->DistToHomePos(hist) > 2 ) {
		//	 && !ip->CloseToBall(hist)) ||
		//	 (ip->DistToHomePos(hist) > 10 &&
		//	 !ip->ClosestToBall(hist)) ) { // ||
		//	 !ip->BehindBall(hist) ) {
      cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
      cmd->SetPoint(ip->GetRole()->GetHomePosition());
    } else {
      cmd = new CCustomCommand(k, CCMD_TrackBall);
    }
  }

  return cmd;

}

CCommand* CDecision::DecideMidfielder()
{

  const int_type hist = CURRENT_EST;

  CCustomCommand* cmd = NULL;
  t_dt_type dt = ip->GetDT();
  
  if ( k->theBall().GetConfidence(hist) < p->RS_low_confidence ) {
    cmd = new CCustomCommand(k, CCMD_FindBall);
  } else if (dt == DT_OurKickOff) {
    if (ip->SparseMySide(hist) &&
	ip->OuterMidfielder()) {
      if (k->theGame().GetPlayMode() == PM_Our_Kick_Off) {
	cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
	// The coordinates for the centerline straight ahead
 	cmd->SetPoint(CPoint(0, k->theAgent().GetPosY(hist)));
      } else {
	cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
 	cmd->SetVector(ip->GetRole()->GetMoveAlongVector());
      }
    } else if (ip->SparseCenter(hist) &&
 	       ip->CenterMidfielder()) {
      cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
      cmd->SetVector(ip->GetRole()->GetMoveAlongVector());
    } else {
      ip->SetDT(DT_Normal);
      return DecideMidfielder();
    }
  } else if (dt == DT_OurFreeKick) {
    cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
    if ( ip->PlayOnLeftSide() )
      cmd->SetVector(CVector(45, 10));
    else
      cmd->SetVector(CVector(-45, 10));
    //cmd = new CCustomCommand(k, CCMD_MakePassable);
  } else if (dt == DT_MyFreeKick) {
    //    std::cout << "In Midfielder::MyFreeKick!" << std::endl;
    if ( //ip->BehindBall(hist) &&
	 ip->BallKickable(hist) ) {
      if ( ip->GoodForwardPass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 1);
      } else {
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_GetBehindBall);
    }
  } else if (dt == DT_MyCornerKick) {
    if ( ip->BallKickable(hist) ) {
      if ( ip->GoodCornerPass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 1);
      } else if ( ip->GetLastCornerTime() + 50 <
		  k->theGame().GetCurrentTime() ) {
	cmd = new CCustomCommand(k, CCMD_TrackBall);
      } else {
	cmd = new CCustomCommand(k, CCMD_CornerClearBall);
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_GetBehindCorner);
    }
  } else if (dt == DT_OurCornerKick) {
    if ( ip->CenterMidfielder() ) {
      if ( ip->CloseToBall(hist) ) {
	cmd = new CCustomCommand(k, CCMD_MakePassable);
      } else {
	cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
	if ( ip->LeftCornerKick(hist) ) {
	  cmd->SetVector(k->theAgent().GetAbsoluteVectorTo(k->flagRT.GetPosition(), hist));
	} else {
	  cmd->SetVector(k->theAgent().GetAbsoluteVectorTo(k->flagRB.GetPosition(), hist));
	}
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
      cmd->SetVector(ip->GetRole()->GetMoveAlongVector());
    }
    //  } else if (dt == DT_TheirKickOff) {
    //    cmd = new CCustomCommand(k, CCMD_TrackBall);
  } else if ( dt == DT_TheirFreeKick ||
	      dt == DT_TheirKickOff ) {
    if ( ip->DistToHomePos(hist) > 2 ) {
      cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
      cmd->SetPoint(ip->GetRole()->GetHomePosition());
    } else {
      cmd = new CCustomCommand(k, CCMD_TrackBall);
    }    
  } else if (dt == DT_Normal ||
	     //dt == DT_TheirKickOff ||
	     dt == DT_TheirFreeKick ||
	     dt == DT_OurFreeKick) {
    // The DT for the Normal pattern for a midfielder
    if ( ip->ClosestToBall(hist) ||
	 ( ip->CloseToBall(hist) && ip->BehindBall(hist) ) ) {
      if ( ip->BallKickable(hist) ) {
	if ( ip->PossibleToScore(hist) ) {
	  cmd = new CCustomCommand(k, CCMD_Score);
	} else if ( ip->GoodForwardPass(hist) &&
		    k->theAgent().GetPosX(hist) < 30 ) {
	  cmd = new CCustomCommand(k, CCMD_Pass, 1);
	} else if ( ip->DistToClosestOpponentInFront(hist) > 5 ) {
	  cmd = new CCustomCommand(k, CCMD_Dribble, 1);
	  //} else if ( ip->GoodBackwardPass(hist) ) {
	  //cmd = new CCustomCommand(k, CCMD_Pass, 2);
	} else {
	  cmd = new CCustomCommand(k, CCMD_ClearBall);
	}
      } else {
	cmd = new CCustomCommand(k, CCMD_InterceptBall);
      }
    } else if (ip->BallOnTheirSide(hist)) {
      if ( ip->BallPrettyClose(hist) ) {
	cmd = new CCustomCommand(k, CCMD_MakePassable);
      } else {
	cmd = new CCustomCommand(k, CCMD_MoveAlong, 2);
	cmd->SetVector(ip->GetRole()->GetMoveAlongVector());
      }
    } else if (ip->BallOnOurSide(hist)) {
      if ( ip->ClosestToBall(hist) ) { // Shouldn't be possible!
	cmd = new CCustomCommand(k, CCMD_InterceptBall);
      } else if ( ip->BehindBall(hist) ) {
	if ( ip->BallInMyHomeArea(hist) ) {
	  cmd = new CCustomCommand(k, CCMD_InterceptBall);
	} else if ( ip->OpponentInMyHomeArea(hist) ) {
	  cmd = new CCustomCommand(k, CCMD_CutOffPassAngle);
	} else if ( ip->DistToHomePos(hist) > 2 ) {
	  cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
	  cmd->SetPoint(ip->GetRole()->GetHomePosition());
	} else {
	  cmd = new CCustomCommand(k, CCMD_TrackBall);
	}
      } else if ( ip->DistToHomePos(hist) > 2 ) {
	cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
	cmd->SetPoint(ip->GetRole()->GetHomePosition());
      } else {
	cmd = new CCustomCommand(k, CCMD_TrackBall);
      }
    } else {
      std::cout << "[Decision] Something wrong in Decide::Midfielder...\n";
    }
  } else {
    std::cout << "[Decision] Unknown Midfielder DT-type!!" << std::endl;
    ip->SetDT(DT_Normal);
    return DecideMidfielder();
  }

  return cmd;

}

CCommand* CDecision::DecideAttacker()
{

  const int_type hist = CURRENT_EST;

  CCustomCommand* cmd = NULL;
  t_dt_type dt = ip->GetDT();
  
  if ( k->theBall().GetConfidence(hist) < p->RS_medium_confidence ) {
    cmd = new CCustomCommand(k, CCMD_FindBall);
  // The DT for the OurKickOff pattern for an attacker
  } else if (dt == DT_OurKickOff) {
    if ( ip->PlayOnLeftSide() ) {
      if ( ip->BallKickable(hist) ) {
	//	&& ip->BehindBall(hist) ) {
	//cmd = new CCustomCommand(k, CCMD_Pass);
	cmd = new CCustomCommand(k, CCMD_Dribble, 1);
      } else {
	//cmd = new CCustomCommand(k, CCMD_GetBehindBall);
	cmd = new CCustomCommand(k, CCMD_InterceptBall);
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_MakePassable);
      //cmd->SetVector(CVector(10,0));
    }
  } else if (dt == DT_MyFreeKick) {
    //    std::cout << "In Attacker::MyFreeKick!" << std::endl;
    if ( //ip->BehindBall(hist) &&
	 ip->BallKickable(hist) ) {
      if ( ip->GoodForwardPass(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Pass, 1);
      } else {
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else {
      cmd = new CCustomCommand(k, CCMD_GetBehindBall);
    }
    //  } else if (dt == DT_TheirKickOff) {
    //    cmd = new CCustomCommand(k, CCMD_TrackBall);
  } else if ( dt == DT_TheirFreeKick ||
	      dt == DT_TheirKickOff ) {
    if ( ip->DistToHomePos(hist) > 2 ) {
      cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
      cmd->SetPoint(ip->GetRole()->GetHomePosition());
    } else {
      cmd = new CCustomCommand(k, CCMD_TrackBall);
    }    
  } else if ( dt == DT_Normal ||
	      //dt == DT_TheirKickOff ||
	      //dt == DT_TheirFreeKick ||
	      dt == DT_OurFreeKick ||
	      dt == DT_OurCornerKick ) {
    //|| dt == DT_OurKickOff) {
    // The DT for the Normal pattern for an attacker
    if ( ip->BallKickable(hist) ) {
      if ( ip->PossibleToScore(hist) ) {
	cmd = new CCustomCommand(k, CCMD_Score);
      } else if (ip->GoodForwardPass(hist) &&
		 k->theAgent().GetPosX(hist) < 30) {
	cmd = new CCustomCommand(k, CCMD_Pass, 1);
      } else if ( ip->DistToClosestOpponentInFront(hist) > 5 ) {
	cmd = new CCustomCommand(k, CCMD_Dribble, 1);
      } else {
	cmd = new CCustomCommand(k, CCMD_ClearBall);
      }
    } else if ( ( ip->BallOnTheirSide(hist) &&
		  ip->BallOnMySide(hist) ) ||
		( ip->BehindBall(hist) &&
		  !ip->PlayerCloserToBallAndBehindBall(hist) ) ) {
      cmd = new CCustomCommand(k, CCMD_InterceptBall);
    } else if ( ip->BallOnTheirSide(hist) &&
		ip->BallPrettyClose(hist) ) {
      cmd = new CCustomCommand(k, CCMD_MakePassable);
    } else if (ip->BallOnTheirSide(hist)) {
      cmd = new CCustomCommand(k, CCMD_MoveAlong);
      if ( ip->GetRole()->GetFieldPosition() == PP_Left )
	cmd->SetVector(k->theAgent().GetAbsoluteVectorTo(k->flagGRT.GetPosition(),
							 hist));
      else
	cmd->SetVector(k->theAgent().GetAbsoluteVectorTo(k->flagGRB.GetPosition(),
							 hist));
    } else if ( ip->DistToHomePos(hist) > 2 ) {
      cmd = new CCustomCommand(k, CCMD_MoveTo, 2);
      cmd->SetPoint(ip->GetRole()->GetHomePosition());
    /*
    } else if (ip->DistToLastPlayer(hist) > 0) {
      // Not in offside be as far up as possible...
      if ( ip->GetRole()->GetFieldPosition() == PP_Left )
	cmd->SetVector(k->theAgent().GetAbsoluteVectorTo(k->flagGRT.GetPosition(),
							 hist));
      else
	cmd->SetVector(k->theAgent().GetAbsoluteVectorTo(k->flagGRB.GetPosition(),
							 hist));
     */
      //    } else if ( ip->DistToLastPlayer(hist) < 2 ) {      
    } else {
      cmd = new CCustomCommand(k, CCMD_TrackBall);
    }
  } else {
    std::cout << "[Decision] Unknown Attacker DT-type!!" << std::endl;
    ip->SetDT(DT_Normal);
    return DecideAttacker();
  }

  return cmd;

}
