#include "CDefender.h"

CDefender::CDefender(const CKnowledge* const kb)
  : CSoccerPlayer(ROLE_Defender),
    k(kb),
    follow_ball_factor(0)
{
}

CPoint CDefender::GetHomePosition() const
{
  CPoint tmp_pos = init_position;
  float_type ball_x = k->theBall().GetPosX(CURRENT_EST);
  float_type ball_y = k->theBall().GetPosY(CURRENT_EST);
  float_type my_x = k->theAgent().GetPosX(CURRENT_EST);
  float_type my_y = k->theAgent().GetPosY(CURRENT_EST);

  if ( k->theBall().GetConfidence() < k->GetParameters()->RS_low_confidence )
    return tmp_pos;

  /*
  if (ball_x > 0.0)
    ball_x += k->GetParameters()->SP_pitch_length/2.0;
  else
    ball_x = Abs(ball_x);

  if (my_x > 0.0)
    my_x += k->GetParameters()->SP_pitch_length/2.0;
  else
    my_x = Abs(my_x);
  */

  if ( ball_x < -20 )
    /*
    if ( ( ball_y > 0 && my_y > 0 ) ||
	 ( ball_y < 0 && my_y < 0 ) )
      tmp_pos.SetX(ball_x - 1);
    else
    */
    tmp_pos.SetX(-20);
  else if ( ball_x < -40 )
    tmp_pos.SetX(ball_x - 2);
  else if (ball_x > my_x) {
    tmp_pos.AddX((ball_x - my_x) * follow_ball_factor);
    if (tmp_pos.GetX() > 0)
      tmp_pos.SetX(0.0);
  }

  CPoint home_p_dev = GetHomePosDeviation();
  CPoint lr = init_position - home_p_dev;
  CPoint ul = init_position + home_p_dev;
  float_type my_min_y = ul.GetY();
  float_type my_max_y = lr.GetY();
  
  if ( ball_y > my_min_y && ball_y < my_max_y )
    tmp_pos.SetY(ball_y);       
  
  return tmp_pos;
}

/* These are excatly the same as in CSoccerPlayer
CRectangle CDefender::GetHomeArea()
{
  CPoint home_p = GetHomePosition();
  CPoint home_p_dev = GetHomePosDeviation();
  return CRectangle(home_p - home_p_dev, home_p + home_p_dev);
}

CRectangle CDefender::GetFreeKickArea()
{
  return free_kick_area;
}

bool CDefender::DoCornerKickLeft()
{
  return do_corner_kick_left;
}

bool CDefender::DoCornerKickRight()
{
  return do_corner_kick_right;
}

bool CDefender::DoGoalKick()
{
  return do_goal_kick;
}

bool CDefender::DoFreeKick(CPoint pt)
{
  return GetFreeKickArea().Inside(pt);
}

bool CDefender::DoKickOff()
{
  return do_kick_off;
}
*/
