#ifndef _CDEFENDER_H_
#define _CDEFENDER_H_

#include "CSoccerPlayer.h"
#include "CKnowledge.h"

class CDefender : public CSoccerPlayer
{
public:
  CDefender(const CKnowledge* const kb);
  //virtual ~CDefender();  

  virtual const CDefender* const GetDefender() const;
  virtual CDefender* GetDefender();
  
  float_type GetFollowBallFactor() const;
  void SetFollowBallFactor(const float_type new_follow_ball_factor);

  virtual CPoint GetHomePosition() const;

  /* These can be overridden.
  virtual CPoint GetHomePosDeviation() const;
  virtual CRectangle GetHomeArea() const;

  virtual CVector GetMoveAlongVector() const;

  virtual CRectangle GetFreeKickArea() const;
  virtual t_field_pos GetFieldPosition() const;

  virtual bool DoCornerKickLeft();
  virtual bool DoCornerKickRight();
  virtual bool DoGoalKick();
  virtual bool DoFreeKick(CPoint);
  virtual bool DoKickOff();
  */
  
protected:
  const CKnowledge* const k;
  float_type follow_ball_factor;
  
};

inline const CDefender* const CDefender::GetDefender() const
{
  return this;
}

inline CDefender* CDefender::GetDefender()
{
  return this;
}

inline float_type CDefender::GetFollowBallFactor() const
{
  return follow_ball_factor;
}

inline void CDefender::SetFollowBallFactor(const float_type new_follow_ball_factor)
{
  follow_ball_factor = new_follow_ball_factor;
}

#endif
