#include "CFCFooAgent.h"

CFCFooAgent::CFCFooAgent(const CParameters* const p,
			 const int_type hist_length)
  : CAgentObject(p, hist_length),
    roles(max_length)
{
}

CFCFooAgent::CFCFooAgent(const CFCFooAgent& obj)
  : CAgentObject(obj),
    roles(obj.roles)
{
}

/*
CFCFooAgent::~CFCFooAgent()
{
}
*/

void CFCFooAgent::CopyData(const CFCFooAgent& obj)
{
  CAgentObject::CopyData(obj);
  roles = obj.roles;
}

CFCFooAgent& CFCFooAgent::operator= (const CFCFooAgent& obj)
{

  if (this != &obj) {
    CopyData(obj);
  }

  return *this;
  
}

void CFCFooAgent::Copy(const int_type from, const int_type to)
{
  CAgentObject::Copy(from, to);
  roles[GetIndex(to)] = roles[GetIndex(from)];
}

void CFCFooAgent::ResetAll()
{
  Reset();

  for (int_type i=0; i < max_length; ++i)
    Reset(i);

}

void CFCFooAgent::Reset()
{

  CAgentObject::Reset();

}

void CFCFooAgent::Reset(const int_type i)
{

  CAgentObject::Reset(i);

  roles[GetIndex(i)] = NULL;

}

void CFCFooAgent::NewCycle()
{

  CAgentObject::NewCycle();
  Copy(PREV, NOW);

}

t_role_type CFCFooAgent::GetRoleType(const int_type hist) const
{
  const CSoccerPlayer* const tmp = GetRole(hist);
  if ( tmp == NULL )
    return ROLE_Unknown;
  else
    return tmp->GetType();
}

CPoint CFCFooAgent::GetInitPosition(const int_type hist) const
{
  const CSoccerPlayer* const tmp = GetRole(hist);
  if ( tmp == NULL )
    return UNKNOWN_POINT;
  else
    return tmp->GetInitPosition();
}
