#ifndef _CFCFOOAGENT_H_
#define _CFCFOOAGENT_H_

#include "CAgentObject.h"
#include "CGoalKeeper.h"
#include "CDefender.h"
#include "CMidfielder.h"
#include "CAttacker.h"

class CFCFooAgent : public CAgentObject
{
public:
  CFCFooAgent(const CParameters* const p,
	      const int_type hist_length = DEFAULT_HIST_LENGTH);
  CFCFooAgent(const CFCFooAgent& obj);
  ~CFCFooAgent();

  CFCFooAgent& operator= (const CFCFooAgent& obj);

  void Copy(const int_type from, const int_type to);

  void ResetAll();
  void Reset();
  void Reset(const int_type i);

  void NewCycle();

  void SetRole(const CSoccerPlayer* const new_role, const int_type hist = NEXT);
  const CSoccerPlayer* const GetRole(const int_type hist = NOW) const;

  t_role_type GetRoleType(const int_type hist = NOW) const;
  CPoint GetInitPosition(const int_type hist = NOW) const;

protected:
  std::vector<const CSoccerPlayer*> roles;

  void CopyData(const CFCFooAgent& obj);
};

inline void CFCFooAgent::SetRole(const CSoccerPlayer* const new_role,
				 const int_type hist)
{
  roles[GetIndex(hist)] = new_role;
}

inline const CSoccerPlayer* const CFCFooAgent::GetRole(const int_type hist) const
{
  return roles[GetIndex(hist)];
}

#endif
