#ifndef _CFCFOOIP_H_
#define _CFCFOOIP_H_

#include "CAdvancedIP.h"
#include "CSoccerPlayer.h"
#include "FCFoo_types.h"

class CFCFooIP : public CAdvancedIP
{
public:
  CFCFooIP(CSoccerPlayer*& role, CKnowledge* const k, CLogFile* const logfile);
  CFCFooIP(const CFCFooIP&);
  //virtual ~CFCFooIP();

  const CSoccerPlayer* const GetRole() const;
  CSoccerPlayer* GetRole();
  void SetRole(CSoccerPlayer* const new_role);
  
  t_dt_type GetDT() const;
  void SetDT(const t_dt_type new_dt);
  
  t_mode_type GetMode() const;
  void SetMode(const t_mode_type new_mode);

  CPoint GoaliePos(const int_type hist) const;
  CPoint GoalieCatchPoint(const int_type hist) const;
  
  float_type DistToHomePos(const int_type hist) const;
  bool BallInMyHomeArea(const int_type hist) const;
  bool BallOnMySide(const int_type hist) const;
  bool SparseMySide(const int_type hist) const;
  bool OpponentInMyHomeArea(const int_type hist) const;
  bool OuterPlayer() const;
  bool InnerPlayer() const;
  bool PlayOnLeftSide() const;
  bool PlayOnRightSide() const;
  bool PlayInCenter() const;
  bool GoalKeeper() const;
  bool Defender() const;
  bool Midfielder() const;
  bool OuterMidfielder() const;
  bool InnerMidfielder() const;
  bool CenterMidfielder() const;
  bool Attacker() const;

protected:
  CSoccerPlayer*& current_role;
  t_dt_type current_dt;
  t_mode_type current_mode;
  
private:
  // So the compiler won't generate an assignment operator.
  CFCFooIP& operator =(const CFCFooIP&);
};

inline const CSoccerPlayer* const CFCFooIP::GetRole() const
{
  return current_role;
}

inline CSoccerPlayer* CFCFooIP::GetRole()
{
  return current_role;
}

inline void CFCFooIP::SetRole(CSoccerPlayer* const new_role)
{
  current_role = new_role;
}
  
inline t_dt_type CFCFooIP::GetDT() const
{
  return current_dt;
}

inline void CFCFooIP::SetDT(const t_dt_type new_dt)
{
  current_dt = new_dt;
}
  
inline t_mode_type CFCFooIP::GetMode() const
{
  return current_mode;
}

inline void CFCFooIP::SetMode(const t_mode_type new_mode)
{
  current_mode = new_mode;
}
  
#endif
