#ifndef _CLINEOBJECT_H_
#define _CLINEOBJECT_H_

#include "CStationaryObject.h"

class CLineObject : public CStationaryObject
{
  
public:
  CLineObject(const t_side_line = DEFAULT_LINE,
	      const int_type hist_len = DEFAULT_HIST_LENGTH);
  CLineObject(const CLineObject& obj);

  CLineObject& operator= (const CLineObject& obj);

  void ResetAll();
  void Reset();
  
  inline void SetLineId(const t_side_line line);
  inline t_side_line GetLineId() const;

  CAngleDeg GetAbsoluteAngle(const int_type hist) const;
  
protected:
  void CopyData(const CLineObject&);
  
private:
  t_side_line line_id;

  static const t_side_line DEFAULT_LINE;  
};

inline void CLineObject::SetLineId(const t_side_line line)
{
  line_id = line;
}

inline t_side_line CLineObject::GetLineId() const
{
  return line_id;
}

#endif
