#ifndef _CLOGFILE_H_
#define _CLOGFILE_H_

#include <fstream>
#include <string>
#include "CKnowledge.h"
#include "CCommand.h"

class CLogFile //: public ofstream
{
public:
  CLogFile(CKnowledge* kb, const std::string& fname,
	   const bool append = true);
  //  ~CLogFile();

  bool Open();
  bool Close();
  bool IsOpen() const;

  void LogText(const std::string& txt);
  void LogGameStatus();
  void LogAgentStatus(const int_type hist = NOW);
  void LogAgentLocation(const int_type hist = NOW);
  void LogBallLocation(const int_type hist = NOW);
  void LogSentCommand(const CCommand* const cmd);

protected:
  void LogNewFormattedEntry();
  void LogNewUnformattedEntry();
  
private:
  CKnowledge* k;
  const std::string filename;
  const bool append;
  bool open;
  std::ofstream log;
  
};

inline bool CLogFile::IsOpen() const
{
  return open;
}
  
inline void CLogFile::LogNewFormattedEntry()
{
  log << k->theGame().GetCurrentTime() << " : ";
}

inline void CLogFile::LogNewUnformattedEntry()
{
  log << k->theGame().GetCurrentTime() << " # ";
}

#endif
