#ifndef _CMARKEROBJECT_H_
#define _CMARKEROBJECT_H_

#include "CStationaryObject.h"

class CMarkerObject : public CStationaryObject
{
public:
  CMarkerObject(const t_marker = DEFAULT_MARKER,
		const CPoint& = CPoint(),
		const int_type = DEFAULT_HIST_LENGTH);
  CMarkerObject(const CMarkerObject& obj);

  CMarkerObject& operator= (const CMarkerObject& obj);

  void ResetAll();
  void Reset();
  
  void SetMarkerId(const t_marker marker);
  t_marker GetMarkerId() const;

  void Rotate();

  CPoint GetAbsolutePosition(const CAngleDeg& obj_ang, const int_type hist) const;
  
protected:
  t_marker marker_id;

  static const t_marker DEFAULT_MARKER;
  
  void CopyData(const CMarkerObject&);

};

bool operator <(const CMarkerObject& obj1, const CMarkerObject& obj2);

inline void CMarkerObject::SetMarkerId(const t_marker marker)
{
  marker_id = marker;
}

inline t_marker CMarkerObject::GetMarkerId() const
{
  return marker_id;
}

inline void CMarkerObject::Rotate()
{
  SetPosition(-GetPosition());
}

#endif
