#ifndef _CMESSAGE_H_
#define _CMESSAGE_H_

#include <string>
#include "CTime.h"
#include <iostream>

class CMessage
{
public:
  CMessage(const std::string&, const CTime&);
  ~CMessage();

  const std::string GetMessage() const;
  void SetMessage(const std::string&);

  CTime GetTime();
  void SetTime(const CTime&);

  friend std::ostream& operator<<(std::ostream&, const CMessage&);
  
protected:
  std::string message;
  CTime time;
};

inline const std::string CMessage::GetMessage() const
{
  return message;
}

inline void CMessage::SetMessage(const std::string& msg)
{
  message = msg;
}

inline CTime CMessage::GetTime()
{
  return time;
}

inline void CMessage::SetTime(const CTime& tm)
{
  time = tm;
}   

inline std::ostream& operator<<(std::ostream& os, const CMessage& msg)
{
  return os << "<" << msg.message << "," << msg.time << ">";
}

#endif
