#ifndef _CMESSAGES_H_
#define _CMESSAGES_H_

#include <deque>
#include "CMessage.h"

class CMessages
{
public:
  CMessages();
  CMessages(const CMessages&);
  ~CMessages();

  CMessages& operator=(const CMessages&);

  CMessage& Front();
  const CMessage& Front() const;

  CMessage& Back();
  const CMessage& Back() const;

  void PushFront(const CMessage&);
  void PushBack(const CMessage&);
  
  void PopFront();
  void PopBack();

  void RemoveFront(const unsigned int);
  void RemoveBack(const unsigned int);
  
  void MakeEmpty();
  bool Empty() const;
  unsigned int Length() const;

protected:
  std::deque<CMessage> messages;
};

inline CMessage& CMessages::Front()
{
  return messages.front();
}

inline const CMessage& CMessages::Front() const
{
  return messages.front();
}

inline CMessage& CMessages::Back()
{
  return messages.back();
}

inline const CMessage& CMessages::Back() const
{
  return messages.back();
}

inline void CMessages::PushFront(const CMessage& msg)
{
  messages.push_front(msg);
}

inline void CMessages::PushBack(const CMessage& msg)
{
  messages.push_back(msg);
}
  
inline void CMessages::PopFront()
{
  messages.pop_front();
}

inline void CMessages::PopBack()
{
  messages.pop_back();
}

inline bool CMessages::Empty() const
{
  return messages.empty();
}

inline unsigned int CMessages::Length() const
{
  return messages.size();
}

#endif
