#include "CMidfielder.h"

CMidfielder::CMidfielder(const CKnowledge* const kb)
  : CDefender(kb),
    move_along_factor(0)
{
  role_type = ROLE_Midfielder;
}

CPoint CMidfielder::GetHomePosition() const
{
  CPoint tmp_pos = init_position;
  float_type ball_x = k->theBall().GetPosX(CURRENT_EST);
  float_type ball_y = k->theBall().GetPosY(CURRENT_EST);
  float_type my_x = k->theAgent().GetPosX(CURRENT_EST);
  float_type my_y = k->theAgent().GetPosY(CURRENT_EST);

  if ( k->theBall().GetConfidence() < k->GetParameters()->RS_low_confidence )
    return tmp_pos;

  /*
  if (ball_x > 0.0)
    ball_x += k->GetParameters()->SP_pitch_length/2.0;
  else
    ball_x = Abs(ball_x);

  if (my_x > 0.0)
    my_x += k->GetParameters()->SP_pitch_length/2.0;
  else
    my_x = Abs(my_x);
  */

  if ( ball_x < -25 )
    tmp_pos.SetX(-25);
  else if (ball_x > my_x) {
    tmp_pos.AddX((ball_x - my_x) * follow_ball_factor);

    CPoint home_p_dev = GetHomePosDeviation();
    CPoint lr = init_position - home_p_dev;
    CPoint ul = init_position + home_p_dev;
    float_type my_min_y = ul.GetY();
    float_type my_max_y = lr.GetY();
  
    if ( ball_y > my_min_y && ball_y < my_max_y )
      tmp_pos.SetY(ball_y);       
  }

  return tmp_pos;

}

/* These are the same as in CSoccerPlayer
CRectangle CMidfielder::GetHomeArea()
{
  CPoint home_p = GetHomePosition();
  CPoint home_p_dev = GetHomePosDeviation();
  return CRectangle(home_p - home_p_dev, home_p + home_p_dev);
}

CRectangle CMidfielder::GetFreeKickArea()
{
  return free_kick_area;
}

bool CMidfielder::DoCornerKickLeft()
{
  return do_corner_kick_left;
}

bool CMidfielder::DoCornerKickRight()
{
  return do_corner_kick_right;
}

bool CMidfielder::DoGoalKick()
{
  return do_goal_kick;
}

bool CMidfielder::DoFreeKick(CPoint pt)
{
  return GetFreeKickArea().Inside(pt);
}

bool CMidfielder::DoKickOff()
{
  return do_kick_off;
}
*/
