#ifndef _CMIDFIELDER_H_
#define _CMIDFIELDER_H_

#include "CDefender.h"

class CMidfielder : public CDefender
{
public:
  CMidfielder(const CKnowledge* const kb);
  //virtual ~CMidfielder();

  virtual const CDefender* const GetDefender() const;
  virtual CDefender* GetDefender();
  virtual const CMidfielder* const GetMidfielder() const;
  virtual CMidfielder* GetMidfielder();

  float_type GetMoveAlongFactor() const;
  void SetMoveAlongFactor(const float_type new_move_along_factor);
  
  virtual CPoint GetHomePosition() const;

  /* These can be overridden.
  virtual CPoint GetHomePosDeviation() const;
  virtual CRectangle GetHomeArea() const;

  virtual CVector GetMoveAlongVector() const;

  virtual CRectangle GetFreeKickArea() const;
  virtual t_field_pos GetFieldPosition() const;

  virtual bool DoCornerKickLeft();
  virtual bool DoCornerKickRight();
  virtual bool DoGoalKick();
  virtual bool DoFreeKick(CPoint);
  virtual bool DoKickOff();
  */
  
protected:
  float_type move_along_factor;
  
};

inline const CDefender* const CMidfielder::GetDefender() const
{
  Error();
  return NULL;
}

inline CDefender* CMidfielder::GetDefender()
{
  Error();
  return NULL;
}

inline const CMidfielder* const CMidfielder::GetMidfielder() const
{
  return this;
}

inline CMidfielder* CMidfielder::GetMidfielder()
{
  return this;
}

inline float_type CMidfielder::GetMoveAlongFactor() const
{
  return move_along_factor;
}

inline void CMidfielder::SetMoveAlongFactor(const float_type new_move_along_factor)
{
  move_along_factor = new_move_along_factor;
}

#endif
