#ifndef _CMOVECOMMAND_H_
#define _CMOVECOMMAND_H_

#include "CCommand.h"
#include "CPoint.h"

enum t_move_type {
  MOVE_Unknown,
  MOVE_Dest
};

class CMoveCommand : public CCommand
{
public:
  CMoveCommand(CKnowledge* const kb, const CPoint& dest = 0,
	       const t_priority prio = PRIO_NORMAL,
	       const CTime& s_time = 0, const CTime& f_time = 0);
  CMoveCommand(const CMoveCommand& obj);
  virtual ~CMoveCommand();

  CMoveCommand& operator =(const CMoveCommand& obj);
  
  virtual const CMoveCommand* const GetMoveCommand() const;
  virtual CMoveCommand* GetMoveCommand();

  void MoveDestination(const CPoint& dest);

  t_move_type GetMoveType() const;
  void SetMoveType(const t_move_type);  
  
  CPoint GetDestination() const;
  void SetDestination(const CPoint& new_destination);

  virtual void UpdateAfterCommand(const int_type from, const int_type to) const;
  virtual bool Validate(const int_type hist);

  virtual const std::string ServerString() const;

private:
  t_move_type move_type;
  CPoint destination;

  void CopyCommand(const CMoveCommand& obj);  
};

inline const CMoveCommand* const CMoveCommand::GetMoveCommand() const
{
  return this;
}

inline CMoveCommand* CMoveCommand::GetMoveCommand()
{
  return this;
}

inline t_move_type CMoveCommand::GetMoveType() const
{
  return move_type;
}

inline void CMoveCommand::SetMoveType(const t_move_type new_move_type)
{
  move_type = new_move_type;
}
  
inline CPoint CMoveCommand::GetDestination() const
{
  return destination;
}

inline void CMoveCommand::SetDestination(const CPoint& new_destination)
{
  destination = new_destination;
}

#endif
