#include "CPoint.h"

CPoint::CPoint(const float_type pt_x, const float_type pt_y)
  : x(pt_x),
    y(pt_y)
{
}

CPoint::CPoint(const CPoint& pt)
  : x(pt.x),
    y(pt.y)
{
}

CPoint::CPoint(const CVector& v, const CPoint& pt)
{
  *this = v + pt;
}

CPoint::CPoint(const CPoint& pt, const CVector& v)
{
  *this = v + pt;
}

CPoint::CPoint(const CVector& v)
{
  *this = CPoint(CPoint(), v);
}

CPoint CPoint::operator-(const CVector& v) const
{
  return (-v) + *this;
}

CPoint CPoint::operator+(const CVector& v) const
{
  return v+*this;
}

CVector CPoint::VectorTo(const CPoint& pt) const
{
  return CVector(*this, pt);
}

std::istream& operator>>(std::istream& is, CPoint& pt)
{
  /* Input formats: f is a floating-point number
	(f,f) = (f,f)
  */

  float_type pt_x = 0.0;
  float_type pt_y = 0.0;
  char c = 0;

  is >> c;
  if (c == '(') {
    is >> pt_x >> c;
    if (c == ',') is >> pt_y >> c;
    if (c != ')') is.clear(std::ios::badbit); //error...;
  }
  else {
    is.clear(std::ios::badbit); //error...;
  }

  if (is) pt = CPoint(pt_x, pt_y);

  return is;
}

