#include "CPrimAct.h"

CPrimAct::CPrimAct(CBasicIP* const b_ip)
  : ip(b_ip),
    k(ip->GetKnowledge()),
    p(k->GetParameters())
{
}

/*
CPrimAct::~CPrimAct()
{
}
*/

CCommand* CPrimAct::Decied(CCommand* next_cmd) const
{
  // cout << "In PrimAct!" << endl;

  if (next_cmd == NULL) {
    // If nothing new from above we either continue with the
    // last task or do nothing.
    std::cerr << "PrimAct got a NULL command!\n";
    return NULL;
  } else {
    switch (next_cmd->GetType())
      {
      case CMD_Catch     : return Catch(next_cmd);
	break;
      case CMD_Dash      : return Dash(next_cmd);
	break;
      case CMD_Kick      : return Kick(next_cmd);
	break;
      case CMD_Move      : return Move(next_cmd);
	break;
      case CMD_Say       : return Say(next_cmd);
	break;
      case CMD_Turn      : return Turn(next_cmd);
	break;
      case CMD_TurnNeck  : return TurnNeck(next_cmd);
	break;
      default            :
	std::cerr << "PrimAct: Unknown command! type:"
		  << next_cmd->GetType() << std::endl;
	return NULL;
      }
  }
}

CCommand* CPrimAct::Catch(CCommand* nxt_cmd) const
{

  // Select the appropriate procedure to calculate the angle of the catch.
  // Then update the CCatchCommand object and return it.

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
  
}

CCommand* CPrimAct::Dash(CCommand* nxt_cmd) const
{

  // Select the appropriate procedure to calculate the power of the dash.
  // Then update the CDashCommand object and send it to the server.

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
    
}
  
CCommand* CPrimAct::Kick(CCommand* nxt_cmd) const
{

  // Select the appropriate procedure to calculate the angle and power of the kick.
  // Then update the CKickCommand object and send it to the server.

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
  
}

CCommand* CPrimAct::Move(CCommand* nxt_cmd) const
{

  // Select the appropriate procedure to calculate the destination of the move.
  // Then update the CMoveCommand object and send it to the server.

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
  
}

CCommand* CPrimAct::Say(CCommand* nxt_cmd) const
{

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
  
}

CCommand* CPrimAct::Turn(CCommand* nxt_cmd) const
{

  // Select the appropriate procedure to calculate the angle of the turn.
  // Then update the CTurnCommand object and send it to the server.

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
  
}
  
CCommand* CPrimAct::TurnNeck(CCommand* nxt_cmd) const
{

  // Select the appropriate procedure to calculate the angle of the turn_neck.
  // Then update the CTurnNeckCommand object and send it to the server.

  nxt_cmd->Validate(CURRENT_EST);
  return nxt_cmd;
  
}
