#ifndef _CPRIORITY_H_
#define _CPRIORITY_H_

#include "types.h"
#include <iostream>

class CPriority
{
public:
  CPriority(const float_type c = 1.0, const float_type min_c = 0.0, const float_type max_c = 1.0);
  CPriority(const CPriority&);

  // Should plus and minus be defined on CPriority?
  // Does it really "mean" anything?
  // Can it be negative?
  inline CPriority operator -() const;
  inline CPriority operator +(const CPriority&) const;
  inline CPriority operator +(const float_type) const;
  inline CPriority operator -(const CPriority&) const;
  inline CPriority operator -(const float_type) const;
  inline CPriority operator *(const CPriority&) const;
  inline CPriority operator *(const float_type) const;
  inline CPriority operator /(const CPriority&) const;
  inline CPriority operator /(const float_type) const;
  
  inline CPriority& operator +=(const CPriority&);
  inline CPriority& operator +=(const float_type);
  inline CPriority& operator -=(const CPriority&);
  inline CPriority& operator -=(const float_type);
  inline CPriority& operator *=(const CPriority&);
  inline CPriority& operator *=(const float_type);
  inline CPriority& operator /=(const CPriority&);
  inline CPriority& operator /=(const float_type);

  inline bool operator ==(const CPriority&) const;
  inline bool operator ==(const float_type) const;
  inline bool operator !=(const CPriority&) const;
  inline bool operator !=(const float_type) const;
  inline bool operator > (const CPriority&) const;
  inline bool operator > (const float_type) const;
  inline bool operator >=(const CPriority&) const;
  inline bool operator >=(const float_type) const;
  inline bool operator < (const CPriority&) const;
  inline bool operator < (const float_type) const;
  inline bool operator <=(const CPriority&) const;
  inline bool operator <=(const float_type) const;
  inline bool operator ! () const;

  inline void SetMinPriority();
  inline void SetMaxPriority();
  inline void SetPriority(const float_type);
  inline float_type GetPriority() const;

  inline void SetMaxPriority(const float_type);
  inline float_type GetMaxPriority() const;
  inline void SetMinPriority(const float_type);
  inline float_type GetMinPriority() const;

  inline friend std::ostream& operator<<(std::ostream&, const CPriority&);
  inline friend std::istream& operator>>(std::istream&, CPriority&);
  
private:
  float_type priority;
  float_type min_conf;
  float_type max_conf;
  
};

#if CHECK_DIVISION_BY_ZERO == 1
// Define a constant for CPriority
#endif

#endif
