#include "CRectangle.h"

CRectangle::CRectangle()
{
  upper_left = CPoint();
  lower_right = CPoint();
}

CRectangle::CRectangle(const float_type x1, const float_type y1, const float_type x2, const float_type y2)
{
  upper_left = CPoint(x1, y1);
  lower_right = CPoint(x2, y2);
}

CRectangle::CRectangle(const CRectangle& r)
{ upper_left = r.upper_left;
 lower_right = r.lower_right;
}

CRectangle::CRectangle(const CPoint& pt1, const CPoint& pt2)
{
  upper_left = pt1;
  lower_right = pt2;
}

CRectangle::CRectangle(const CVector& v)
{
  upper_left = CPoint();
  lower_right = CPoint(v);
}

CRectangle::CRectangle(const CVector& v, const CPoint& pt)
{
  upper_left=pt;
  lower_right = pt + v;
}

CRectangle::CRectangle(const CPoint& pt, const CVector& v)
{
  upper_left=pt;
  lower_right = pt + v;
}

CRectangle& CRectangle::operator =(const CRectangle& r)
{
  upper_left = r.upper_left;
  lower_right = r.lower_right;
  return *this;
}

CRectangle& CRectangle::MoveCenter(const CPoint& pt)
{
  CPoint tmp_move = GetCenter() - pt;
  upper_left + tmp_move;
  lower_right + tmp_move;
  return *this;
}

CRectangle& CRectangle::MoveLeft(const float_type d)
{
  upper_left.AddX(-d);
  lower_right.AddX(-d);
  return *this;
}

CRectangle& CRectangle::MoveRight(const float_type d)
{
  upper_left.AddX(d);
  lower_right.AddX(d);
  return *this;
}

CRectangle& CRectangle::MoveUp(const float_type d)
{
  upper_left.AddY(-d);
  lower_right.AddY(-d);
  return *this;
}

CRectangle& CRectangle::MoveDown(const float_type d)
{
  upper_left.AddY(d);
  lower_right.AddY(d);
  return *this;
}
