#include "CSayCommand.h"
#include "CKnowledge.h"

CSayCommand::CSayCommand(CKnowledge* const kb, const std::string& msg,
			 const CTime& time, const t_priority prio,
			 const CTime& s_time, const CTime& f_time)
  : CCommand(kb, CMD_Say, prio, s_time, f_time),
    message(msg, time)
{
}

CSayCommand::CSayCommand(const CSayCommand& obj)
  : CCommand(obj),
    message(obj.message)
{
}

CSayCommand::~CSayCommand()
{
}

void CSayCommand::CopyCommand(const CSayCommand& obj)
{
  CCommand::CopyCommand(obj);
  message = obj.message;
}

CSayCommand& CSayCommand::operator =(const CSayCommand& obj)
{
  if ( this != &obj ) {
    CopyCommand(obj);
  }

  return *this;
}

void CSayCommand::UpdateAfterCommand(const int_type from,
				     const int_type to) const
{
  k->theAgent().SetCyclesSinceSay(0);
  k->theAgent().SentMessages().PushBack(message);
}

bool CSayCommand::Validate(const int_type hist)
{
  return ( message.GetMessage().size() < k->GetParameters()->SP_say_msg_size );
}

const std::string CSayCommand::ServerString() const
{
  return "(say " + message.GetMessage() + ")";
}
