#ifndef _CSAYCOMMAND_H_
#define _CSAYCOMMAND_H_

#include "CCommand.h"
#include "CMessage.h"

class CSayCommand : public CCommand
{
public:
  CSayCommand(CKnowledge* const kb, const std::string& msg,
	      const CTime& time, const t_priority prio = PRIO_NORMAL,
	      const CTime& s_time = 0, const CTime& f_time = 0);
  CSayCommand(const CSayCommand& obj);
  virtual ~CSayCommand();

  CSayCommand& operator =(const CSayCommand& obj);
  
  virtual const CSayCommand* const GetSayCommand() const;
  virtual CSayCommand* GetSayCommand();

  CMessage GetMessage() const;
  void SetMessage(const CMessage& new_msg);

  virtual void UpdateAfterCommand(const int_type from, const int_type to) const;
  virtual bool Validate(const int_type hist);

  virtual const std::string ServerString() const;  

private:
  CMessage message;

  void CopyCommand(const CSayCommand& obj);
};

inline const CSayCommand* const CSayCommand::GetSayCommand() const
{
  return this;
}

inline CSayCommand* CSayCommand::GetSayCommand()
{
  return this;
}

inline CMessage CSayCommand::GetMessage() const
{
  return message;
}

inline void CSayCommand::SetMessage(const CMessage& new_msg)
{
  // This could be optimzed since now we create and copy
  // the string each time. Maybe faster to use pointers,
  // but then it's not as safe...
  message = new_msg;
}

#endif
