#ifndef _CSKILLS_H_
#define _CSKILLS_H_

#include "CAdvancedIP.h"

class CSkills
{
public:
  CSkills(CAdvancedIP* const a_ip);
  CSkills(const CSkills& obj);
  //~CSkills();

  CCommand* Decied(CCommand*);
  
  CCommand* TurnNeck(CCustomCommand* cmd);
  CCommand* Score(CCustomCommand* cmd);
  CCommand* FindBall(CCustomCommand* cmd);
  CCommand* FindPlayer(CCustomCommand* cmd);
  CCommand* Dribble(CCustomCommand* cmd);
  CCommand* MoveTo(CCustomCommand* cmd);
  CCommand* MoveAlong(CCustomCommand* cmd);
  CCommand* TurnBall(CCustomCommand* cmd);
  CCommand* TrackBall(CCustomCommand* cmd);
  CCommand* Pass(CCustomCommand* cmd);
  CCommand* InterceptBall(CCustomCommand* cmd);
  CCommand* MakePassable(CCustomCommand* cmd);
  CCommand* ClearBall(CCustomCommand* cmd);
  CCommand* CornerClearBall(CCustomCommand* cmd);
  CCommand* CutOffPassAngle(CCustomCommand* cmd);
  CCommand* CutOffGoalAngle(CCustomCommand* cmd);
  CCommand* GetBehindBall(CCustomCommand* cmd);
  CCommand* GetBehindCorner(CCustomCommand* cmd);

  CCommand* MarkPlayer();
  CCommand* HoldPosition(CPoint pt, CTime = 0);

  // Goalkeeper skills
  CCommand* GoalieMoveTo(CCustomCommand* cmd);
  CCommand* Catch(CCustomCommand* cmd);
  CCommand* Rush(CCustomCommand* cmd);
  CCommand* GoalKick(CCustomCommand* cmd);

  /*
  // Static situations
  CCommand* GoalKick(CCustomCommand* cmd);
  CCommand* CornerKick(CCustomCommand* cmd);
  CCommand* FreeKick(CCustomCommand* cmd);
  */
  
protected:
  CAdvancedIP* const ip;
  CKnowledge* const k;
  const CRSParameters* const p;

  bool showSkill;
  bool test;

  // So the compiler won't generate an assignment operator.
  CSkills& operator =(const CSkills&);
};

#endif
