#include "CSoccerPlayer.h"

CSoccerPlayer::CSoccerPlayer(const t_role_type new_role_type)
  : role_type(new_role_type),
    init_position(),
    home_pos_deviation(),
    free_kick_area(),
    do_corner_kick_left(false),
    do_corner_kick_right(false),
    do_goal_kick(false),
    do_kick_off(false)
{
}

CSoccerPlayer::~CSoccerPlayer()
{
}

bool CSoccerPlayer::DoCornerKick(const CPoint& ball_pos) const
{
  if ( ball_pos.GetY() > 0 )
    return DoCornerKickRight();
  else
    return DoCornerKickLeft();
}

CRectangle CSoccerPlayer::GetHomeArea() const
{
  CPoint home_p = GetHomePosition();
  CPoint home_p_dev = GetHomePosDeviation();
  return CRectangle(home_p - home_p_dev, home_p + home_p_dev);
}

void CSoccerPlayer::Error() const
{
  std::cout << "Error! Not correct role type!";
  exit(1);
}  
