#ifndef _CSTATIONARYOBJECT_H_
#define _CSTATIONARYOBJECT_H_

#include "CGameObject.h"

class CStationaryObject : public CGameObject
{
public:
  CStationaryObject(const int_type hist_length = DEFAULT_HIST_LENGTH);
  CStationaryObject(const CStationaryObject& obj);

  CStationaryObject& operator=(const CStationaryObject& obj);

  float_type GetPosX(const int_type hist = NOW) const;
  float_type GetPosY(const int_type hist = NOW) const;
  void SetPosition(const CPoint& pos, const int_type hist = NOW);
  CPoint GetPosition(const int_type hist = NOW) const;

protected:
  void CopyData(const CStationaryObject&);
  
};

inline float_type CStationaryObject::GetPosX(const int_type hist) const
{
  return CGameObject::GetPosX(NOW);
}

inline float_type CStationaryObject::GetPosY(const int_type hist) const
{
  return CGameObject::GetPosY(NOW);
}

inline void CStationaryObject::SetPosition(const CPoint& pos, const int_type hist)
{
  CGameObject::SetPosition(pos, NOW);
}

inline CPoint CStationaryObject::GetPosition(const int_type hist) const
{
  return CGameObject::GetPosition(NOW);
}

#endif
