#include "CStrategy.h"

CStrategy::CStrategy(CFCFooIP* const f_ip)
  : ip(f_ip),
    k(ip->GetKnowledge())
{
  test = false;
}

/*
CStrategy::~CStrategy()
{
}
*/

void CStrategy::Decide()
{

  //std::cout << "PlayMode = " << k->theGame().GetPlayMode() << endl;

  //std::cout << k->theGame().GetCurrentTime() << " In strategy." << endl;
  
  if (ip->GoalKeeper()) {
    if ( test ) std::cout << "GoalKeeper. " << endl;
    DecideGoalKeeper();
  } else if (ip->Defender()) {
    if ( test ) std::cout << "Defender. " << endl;
    DecideDefender();
  } else if (ip->Midfielder()) {
    if ( test ) std::cout << "Midfielder. " << endl;
    DecideMidfielder();
  } else if (ip->Attacker()) {
    if ( test ) std::cout << "Attacker. " << endl;
    DecideAttacker();
  } else {
    ip->SetDT(DT_BeforeKickOff);
    std::cout << "[Decide] Problems with the role!" << endl;
  }

  ip->SetMode(MODE_Neutral);
  
}

void CStrategy::DecideGoalKeeper()
{

  const int_type hist = CURRENT_EST;

  switch ( k->theGame().GetPlayMode() ) {
  case PM_Our_Goalie_Got_Ball :
    ip->SetDT(DT_OurGoalieGotBall); break;
  case PM_Before_Kick_Off :
  case PM_Our_Kick_Off :
  case PM_Their_Kick_Off:
  case PM_Our_Goal :
  case PM_Their_Goal :
    ip->SetDT(DT_BeforeKickOff); break;
  case PM_Our_Goal_Kick   :
    ip->SetDT(DT_MyFreeKick);
    break;
  case PM_Our_Kick_In     :
  case PM_Our_Free_Kick   :
    if ( ip->BallInOurPenaltyArea(hist) ) {
      ip->SetDT(DT_MyFreeKick);
      break;
    }
  default : ip->SetDT(DT_Normal);
  }

}

void CStrategy::DecideDefender()
{

  const int_type hist = CURRENT_EST;
  
  switch ( k->theGame().GetPlayMode() ) {
  case PM_Our_Goal :
  case PM_Their_Goal :
  case PM_Before_Kick_Off : ip->SetDT(DT_BeforeKickOff); break;
  case PM_Our_Offside_Kick :
  case PM_Our_Kick_In :
  case PM_Our_Free_Kick :
  case PM_Our_Goal_Kick :
    if ( ip->GetRole()->DoFreeKick(k->theBall().GetPosition(hist)) )
      //ip->CloseToBall(hist) &&
	//!ip->BallInOurPenaltyArea(hist) )
      ip->SetDT(DT_MyFreeKick);
    else
      ip->SetDT(DT_OurFreeKick);
    break;
  case PM_Our_Corner_Kick :
  case PM_Their_Offside_Kick :
  case PM_Their_Kick_In :
  case PM_Their_Free_Kick :
  case PM_Their_Goal_Kick :
  case PM_Their_Corner_Kick : ip->SetDT(DT_TheirFreeKick); break;
  case PM_Our_Kick_Off : ip->SetDT(DT_OurKickOff); break;
  case PM_Their_Kick_Off : ip->SetDT(DT_TheirKickOff); break;
  default : ip->SetDT(DT_Normal);
  }

}

void CStrategy::DecideMidfielder()
{

  const int_type hist = CURRENT_EST;

  switch ( k->theGame().GetPlayMode() ) {
  case PM_Half_Time :
  case PM_Our_Goal :
  case PM_Their_Goal :
  case PM_Before_Kick_Off :
    ip->SetDT(DT_BeforeKickOff);
    break;
  case PM_Our_Offside_Kick :
  case PM_Our_Kick_In :
  case PM_Our_Free_Kick :
  case PM_Our_Goal_Kick :
    if ( ip->ClosestToBall(hist) ||
	 ip->GetRole()->DoFreeKick(k->theBall().GetPosition(hist)) )
      ip->SetDT(DT_MyFreeKick);
    else
      ip->SetDT(DT_OurFreeKick);
    break;
  case PM_Our_Corner_Kick :
    if ( ip->GetRole()->DoCornerKick(k->theBall().GetPosition(hist)) )
      ip->SetDT(DT_MyCornerKick);
    else
      ip->SetDT(DT_OurCornerKick);
    break;
  case PM_Our_Kick_Off :
    ip->SetDT(DT_OurKickOff);
    break;
  case PM_Their_Offside_Kick :
  case PM_Their_Kick_In :
  case PM_Their_Free_Kick :
  case PM_Their_Goal_Kick :
  case PM_Their_Corner_Kick : //ip->SetDT(DT_TheirFreeKick); break;
  case PM_Their_Kick_Off : //ip->SetDT(DT_TheirKickOff); break;
  default :
    ip->SetDT(DT_Normal);
  }

}

void CStrategy::DecideAttacker()
{

  const int_type hist = CURRENT_EST;
    
  switch ( k->theGame().GetPlayMode() ) {
  case PM_Our_Goal :
  case PM_Their_Goal :
  case PM_Before_Kick_Off :
    ip->SetDT(DT_BeforeKickOff);
    break;
  case PM_Our_Offside_Kick :
  case PM_Our_Kick_In :
  case PM_Our_Free_Kick :
  case PM_Our_Goal_Kick :
    /*
    if ( ip->CloseToBall(hist) )
      ip->SetDT(DT_MyFreeKick);
    else
    */
    ip->SetDT(DT_OurFreeKick);
    break;
  case PM_Our_Corner_Kick :
    ip->SetDT(DT_OurCornerKick);
    break;
  case PM_Our_Kick_Off : ip->SetDT(DT_OurKickOff); break;
  case PM_Their_Offside_Kick :
  case PM_Their_Kick_In :
  case PM_Their_Free_Kick :
  case PM_Their_Goal_Kick :
  case PM_Their_Corner_Kick : //ip->SetDT(DT_TheirFreeKick); break;
  case PM_Their_Kick_Off : //ip->SetDT(DT_TheirKickOff); break;
  default : ip->SetDT(DT_Normal);
  }

}
