#include "CTheGameObject.h"

const std::string CTheGameObject::DEFAULT_OUR_TEAM_NAME = "\n";
const std::string CTheGameObject::DEFAULT_THEIR_TEAM_NAME = "\n";
const t_side CTheGameObject::DEFAULT_OUR_SIDE = S_Unknown;
const t_side CTheGameObject::DEFAULT_THEIR_SIDE = S_Unknown;
const t_play_mode CTheGameObject::DEFAULT_PLAY_MODE = PM_Unknown;
const t_kick_off_mode CTheGameObject::DEFAULT_KICK_OFF_MODE = KO_Unknown;

CTheGameObject::CTheGameObject()
  : our_team_name(DEFAULT_OUR_TEAM_NAME),
    their_team_name(DEFAULT_THEIR_TEAM_NAME),
    our_side(DEFAULT_OUR_SIDE),
    their_side(DEFAULT_THEIR_SIDE),
    our_score(0),
    their_score(0),
    current_time(CTime::current_time),
    play_mode(DEFAULT_PLAY_MODE),
    kick_off_mode(DEFAULT_KICK_OFF_MODE)
{

  current_time = CTime(0,0);
  
}

CTheGameObject::CTheGameObject(const CTheGameObject& obj)
  : our_team_name(obj.our_team_name),
    their_team_name(obj.their_team_name),
    our_side(obj.our_side),
    their_side(obj.their_side),
    our_score(obj.our_score),
    their_score(obj.their_score),
    current_time(obj.current_time),
    play_mode(obj.play_mode),
    kick_off_mode(obj.kick_off_mode)
{
  
}

/*
CTheGameObject::~CTheGameObject()
{
}
*/

void CTheGameObject::CopyData(const CTheGameObject& obj)
{
  our_team_name = obj.our_team_name;
  their_team_name = obj.their_team_name;

  our_side = obj.our_side;
  their_side = obj.their_side;
  our_score = obj.our_score;
  their_score = obj.their_score;
  current_time = obj.current_time;
  play_mode = obj.play_mode;
  kick_off_mode = obj.kick_off_mode;
}

CTheGameObject& CTheGameObject::operator= (const CTheGameObject& obj)
{

  if (this != &obj) {
    CopyData(obj);
  }

  return *this;
  
}

void CTheGameObject::ResetAll()
{
  Reset();
}

void CTheGameObject::Reset()
{

  our_team_name = DEFAULT_OUR_TEAM_NAME;
  their_team_name = DEFAULT_THEIR_TEAM_NAME;

  our_side = DEFAULT_OUR_SIDE;
  their_side = DEFAULT_THEIR_SIDE;

  our_score = 0;
  their_score = 0;

  current_time = 0;

  play_mode = DEFAULT_PLAY_MODE;
  kick_off_mode = DEFAULT_KICK_OFF_MODE;

}

void CTheGameObject::SetOurSide(const t_side new_side)
{

  our_side = new_side;

  if (our_side == S_Left)
    their_side = S_Right;
  else
    their_side = S_Left;
  
}

void CTheGameObject::SetTheirSide(const t_side new_side)
{

  their_side = new_side;

  if (their_side == S_Left)
    our_side = S_Right;
  else
    our_side = S_Left;

}
