#include "CTurnCommand.h"
#include "CDashCommand.h"
#include "CKickCommand.h"
#include "CMoveCommand.h"
#include "CLogFile.h"
#include "CFCFooIP.h"
//#include "CFCFooAgent.h" // Not useful since CKnowledge makes a copy!

#include "CSoccerPlayer.h"
#include "CGoalKeeper.h"
#include "CDefender.h"
#include "CMidfielder.h"
#include "CAttacker.h"

#include "CServerIFace.h"
//#include "CPrimAct.h" // Everything is moved to the commands!
#include "CSkills.h"
#include "CDecision.h"
#include "CStrategy.h"

//#include <iostream>
//#include <sys/time.h>

CSoccerPlayer* CreateRole(const t_unum my_number, CKnowledge* k)
{

  CSoccerPlayer* new_role;
  const CRSParameters* const p = k->GetParameters();
  
  if (my_number == 1 &&
      k->theAgent().IsGoalie()) { // Goalkeeper
    CGoalKeeper *tmp_role = new CGoalKeeper();
    tmp_role->SetInitPosition(CPoint(-47, 0));
    tmp_role->SetHomePosDeviation(CPoint(p->SP_pitch_length/2.0 - 47, p->SP_goal_width/2.0));
    tmp_role->SetFreeKickArea(CRectangle(k->flagLB20.GetPosition(),
					 k->flagPLT.GetPosition()));
    tmp_role->SetFieldPosition(PP_Center);
    tmp_role->SetDoGoalKick(true);
    new_role = tmp_role;
  } else if (my_number == 2) { // Left outer defender
    CDefender *tmp_role = new CDefender(k);
    tmp_role->SetType(ROLE_OuterDefender);
    tmp_role->SetInitPosition(CPoint(-25, -25));
    tmp_role->SetHomePosDeviation(CPoint(25, -10));
    tmp_role->SetFreeKickArea(CRectangle(k->flagLT20.GetPosition(),
					 CPoint(0, k->flagCT.GetPosY())));
    tmp_role->SetFieldPosition(PP_OuterLeft);
    tmp_role->SetFollowBallFactor(0.5);
    new_role = tmp_role;
  } else if (my_number == 3) { // Left inner defender
    CDefender *tmp_role = new CDefender(k);
    tmp_role->SetType(ROLE_InnerDefender);
    tmp_role->SetInitPosition(CPoint(-30, -10));
    tmp_role->SetHomePosDeviation(CPoint(30, -10));
    // Rect(Flag_PLT, Flag_C)
    tmp_role->SetFreeKickArea(CRectangle(CPoint(k->flagPLT.GetPosX(),
						k->flagGLT.GetPosY()),
					 CPoint(0, -20)));
    tmp_role->SetFieldPosition(PP_InnerLeft);
    tmp_role->SetFollowBallFactor(0.3);
    new_role = tmp_role;
  } else if (my_number == 4) { // Center defender
    CDefender *tmp_role = new CDefender(k);
    tmp_role->SetType(ROLE_CenterDefender);
    tmp_role->SetInitPosition(CPoint(-25, 0));
    tmp_role->SetHomePosDeviation(CPoint(25, -10));
    // Rect(Flag_PLC, CPoint(0,20))
    tmp_role->SetFreeKickArea(CRectangle(CPoint(k->flagPLT.GetPosX(), k->flagGLB.GetPosY()),
					 CPoint(0.0, k->flagGLT.GetPosY())));
    tmp_role->SetFieldPosition(PP_Center);
    tmp_role->SetFollowBallFactor(0.2);    
    new_role = tmp_role;
  } else if (my_number == 5) { // Right inner defender
    CDefender *tmp_role = new CDefender(k);
    tmp_role->SetType(ROLE_InnerDefender);
    tmp_role->SetInitPosition(CPoint(-30, 10));
    tmp_role->SetHomePosDeviation(CPoint(30, -10));
    tmp_role->SetFreeKickArea(CRectangle(k->flagPLB.GetPosition(),
					 CPoint(0, k->flagGLB.GetPosY())));
    tmp_role->SetFieldPosition(PP_InnerRight);
    tmp_role->SetFollowBallFactor(0.3);
    new_role = tmp_role;
  } else if (my_number == 6) { // Right outer defender
    CDefender *tmp_role = new CDefender(k);
    tmp_role->SetType(ROLE_OuterDefender);
    tmp_role->SetInitPosition(CPoint(-25, 25));
    tmp_role->SetHomePosDeviation(CPoint(25, -10));
    tmp_role->SetFreeKickArea(CRectangle(CPoint(k->flagLB.GetPosX(),
						k->flagBL50.GetPosY()),
					 CPoint(0, k->flagLB20.GetPosY())));
    tmp_role->SetFieldPosition(PP_OuterRight);
    tmp_role->SetFollowBallFactor(0.5);
    new_role = tmp_role;
  } else if (my_number == 7) { // Left outer midfielder
    CMidfielder *tmp_role = new CMidfielder(k);
    tmp_role->SetType(ROLE_OuterMidfielder);
    tmp_role->SetInitPosition(CPoint(-10, -15));
    tmp_role->SetHomePosDeviation(CPoint(-20, 15));
    tmp_role->SetFreeKickArea(CRectangle(CPoint(0.0, k->flagGLT.GetPosY()),
					 CPoint(k->flagRT.GetPosX(),
						k->flagTR50.GetPosY())));
    tmp_role->SetDoCornerKickLeft(true);
    tmp_role->SetFieldPosition(PP_Left);
    tmp_role->SetMoveAlongVector(CVector(25,0));
    tmp_role->SetMoveAlongFactor(0.7);
    new_role = tmp_role;
  } else if (my_number == 8) { // Center midfielder
    CMidfielder *tmp_role = new CMidfielder(k);
    tmp_role->SetType(ROLE_CenterMidfielder);
    tmp_role->SetInitPosition(CPoint(-10, 0));
    tmp_role->SetHomePosDeviation(CPoint(20, -5));
    tmp_role->SetFreeKickArea(CRectangle(CPoint(0.0, k->flagGLB.GetPosY()),
					 k->flagGRT.GetPosition()));
    tmp_role->SetFieldPosition(PP_Center);
    tmp_role->SetMoveAlongVector(CVector(0,0));    
    tmp_role->SetMoveAlongFactor(0.6);
    new_role = tmp_role;
  } else if (my_number == 9) { // Right outer midfielder
    CMidfielder *tmp_role = new CMidfielder(k);
    tmp_role->SetType(ROLE_OuterMidfielder);
    tmp_role->SetInitPosition(CPoint(-10, 15));
    tmp_role->SetHomePosDeviation(CPoint(20, -15));
    tmp_role->SetFreeKickArea(CRectangle(k->flagB0.GetPosition(),
					 k->flagGRB.GetPosition()));
    tmp_role->SetDoCornerKickRight(true);
    tmp_role->SetFieldPosition(PP_Right);
    tmp_role->SetMoveAlongVector(CVector(-25,0));
    tmp_role->SetMoveAlongFactor(0.7);
    new_role = tmp_role;
  } else if (my_number == 10) { // Left attacker
    CAttacker *tmp_role = new CAttacker(k);
    tmp_role->SetType(ROLE_LeftAttacker);
    tmp_role->SetInitPosition(CPoint(-1, -2));
    tmp_role->SetHomePosDeviation(CPoint(20, -20));
    tmp_role->SetFieldPosition(PP_Left);
    //    tmp_role->SetMoveAlongVector(CVector(-20,0));
    //    tmp_role->SetMoveAlongFactor(0.6);
    tmp_role->SetDoKickOff(true);
    new_role = tmp_role;
  } else if (my_number == 11) { // Right attacker
    CAttacker *tmp_role = new CAttacker(k);
    tmp_role->SetType(ROLE_RightAttacker);
    tmp_role->SetInitPosition(CPoint(-1, 5));
    tmp_role->SetHomePosDeviation(CPoint(20, -20));
    tmp_role->SetFieldPosition(PP_Right);
    //    tmp_role->SetMoveAlongVector(CVector(20,0));
    //    tmp_role->SetMoveAlongFactor(0.6);
    tmp_role->SetDoKickOff(true);
    new_role = tmp_role;
  } else { // Something wrong!!
    cout << "[InitRole] Unknown uniformnumber!" << endl;
    exit(1);
  }

  return new_role;

}

int main(int argc, char** argv)
{
  const string logf_name = "FCFoo.log";
  
  std::cout << "Reading parameters...\n";
  CRSParameters p(argc, argv);

  std::cout << "Initialising " << p.RS_team_name << "...\n";
  CKnowledge    k(&p, CTheGameObject(), CAgentObject(&p), CBallObject(&p),
		  CSetofPlayersObject(&p, 22, false));
  CLogFile      logf(&k, logf_name, false);
  CSoccerPlayer* myRole = NULL;
  CFCFooIP      ip(myRole, &k, &logf);
  CCommandQueue command_queue;

  CServerIFace  server_interface(&ip, &command_queue);
  CSkills skills(&ip);
  CDecision decision(&ip);
  CStrategy strategy(&ip);

  std::cout << "Opening logfile " << logf_name << "...\n";
  logf.Open();

  std::cout << "Initialising the agent...\n";
  k.theGame().SetOurTeamName(p.RS_team_name);
  k.theAgent().SetGoalie(p.RS_goalie);
  k.theAgent().SetConfidenceDecay(p.RS_confidence_decay_player);
  k.theAgent().SetLastActTime(CTime(0,0));
  k.theAgent().SetBodyDir(0, NOW);
  k.theAgent().SetFaceDir(0, NOW);
  k.theAgent().SetNeckDir(0, NOW);
  k.theAgent().SetAcceleration(CVector(0,0), NOW);
  k.theAgent().SetAbsoluteSpeedVector(CVector(0,0), NOW);
  k.theAgent().Copy(NOW, CURRENT_EST);
  k.theAgent().Copy(NOW, PREV);
  k.theAgent().Copy(NOW, NEXT);

  k.theBall().SetConfidenceDecay(p.RS_confidence_decay_ball);
  k.theBall().SetPosition(CPoint(0,0), NOW);
  k.theBall().SetAcceleration(CVector(0,0), NOW);
  k.theBall().SetAbsoluteSpeedVector(CVector(0,0), NOW);
  k.theBall().Copy(NOW, CURRENT_EST);
  k.theBall().Copy(NOW, PREV);
  k.theBall().Copy(NOW, NEXT);

  std::cout << "Initialising connection to server at " << p.SP_host
	    << ":" << p.SP_port << "...\n";
  server_interface.Init(p.SP_host, p.SP_port);

  //server_interface.WaitForNewInformation();
  myRole = CreateRole(k.theAgent().GetUNumber(), &k);
  std::cout << "I am player " << k.theAgent().GetUNumber()
	    << " and I am a";
  switch ( myRole->GetType() ) {
  case ROLE_GoalKeeper:
    std::cout << " Goalkeeper.\n";
    break;
  case ROLE_Attacker:
  case ROLE_LeftAttacker:
  case ROLE_RightAttacker:
    std::cout << "n Attacker.\n";
    break;
  case ROLE_Defender:
  case ROLE_InnerDefender:
  case ROLE_OuterDefender:
  case ROLE_CenterDefender:
    std::cout << " Defender.\n";
    break;
  case ROLE_Midfielder:
  case ROLE_InnerMidfielder:
  case ROLE_OuterMidfielder:
  case ROLE_CenterMidfielder:
    std::cout << " Midfielder.\n";
    break;
  default:
    std::cout << " UNKNOWN ROLETYPE!!\n";
    exit(1);
  }
  
  std::cout << "Starting the server interface...\n";
  server_interface.Start();

  CCommand* cmd = NULL;
  while ( server_interface.ServerAlive() ) {
    if ( server_interface.WaitForNewCycle() ) {
      logf.LogText("new_cycle");
      logf.LogAgentLocation(CURRENT_EST);
      logf.LogBallLocation(CURRENT_EST);
      logf.LogAgentLocation(NEXT_EST);
      logf.LogBallLocation(NEXT_EST);
      command_queue.MakeEmpty();
      strategy.Decide();
      cmd = skills.Decied(decision.Decide());
      if ( cmd != NULL ) {
	command_queue += cmd;
	delete cmd;
	cmd = NULL;
      }
    } else {
      std::cerr << "WaitForNewCycle failed!\n";
    }
  }

  std::cout << "Closing logfile " << logf_name << "...\n";
  logf.Close();

  delete myRole;
  
  return 0;
}
