#ifndef _CONSTANTS_H
#define _CONSTANTS_H

static const int_type NUM_OF_MARKERS = 56;               // In this file?
static const int_type MAX_NUM_LINES   = 4;                // In this file?

static const int_type MAX_TEAMPLAYERS = 11;              // In this file?
static const int_type MAX_NUM_PLAYERS = MAX_TEAMPLAYERS * 2; // In this file?

/*
// timings (in ms)
const int_type       simulator_step  = 100;
const int_type       send_step       = 150;
const int_type       recv_step       =  10;
const int_type       timer_step      =  10;

// min. and max. dash
const float_type    min_dash_power  = -30.0;
const float_type    max_dash_power  = 100.0;

// min. and max. kick
const float_type    min_kick_power  = -30.0;
const float_type    max_kick_power  = 100.0;

// min. and max. moment (turn)
const float_type    min_turn_moment = -180.0;
const float_type    max_turn_moment = 180.0;

// min. and max. neck angle (turn neck)
const float_type    min_neck_angle  = -90.0;
const float_type    max_neck_angle  = 90.0;

// min. and max. moment (kick)
const float_type    min_kick_moment = -180.0;
const float_type    max_kick_moment = 180.0;

// min. and max. moment (catch)
const float_type    min_catch_moment = -180.0;
const float_type    max_catch_moment = 180.0;

// player parameter (default 1.0, 0.5, 0.1, 60.0, 32.0)
const float_type    player_size     = 0.3;
const float_type    player_decay	= 0.4;
const float_type    player_rand	= 0.1;
const float_type    player_weight   = 60.0;
const float_type    player_speed_max= 1.0;

// ball parameter (default 0.15, 0.8, 0.2, 0.2, 32.0)
const float_type    ball_size       = 0.085;
const float_type    ball_decay      = 0.94;
const float_type    ball_rand       = 0.05;         // random parameter
const float_type    ball_weight     = 0.2;
const float_type    ball_speed_max  = 2.7;

// misc. player constants
const float_type    kickable_margin = 0.7;
const float_type    kickable_area   = kickable_margin + ball_size + player_size;
const float_type    kick_power_rate = 0.016;
const float_type    stamina_max     = 3500;
const float_type    stamina_max_inc = 20;
const float_type    recovery_dec_thr= 0.3;
const float_type    recovery_dec    = 0.002;
const float_type    recovery_min    = 0.5;
const float_type    effort_dec_thr  = 0.3;
const float_type    effort_dec      = 0.005;
const float_type    effort_min      = 0.6;
const float_type    effort_inc_thr  = 0.6;
const float_type    effort_inc      = 0.01;

// used in sfield
const float_type    pitch_length            = 105.0;
const float_type    pitch_width             =  68.0;
const float_type    pitch_margin            =   5.0;
const float_type    center_circle_r         =   9.15;
const float_type    penalty_area_length     =  16.5;
const float_type    penalty_area_width      =  40.32;
const float_type    goal_area_length        =   5.5;
const float_type    goal_area_width         =  18.32;
const float_type    goal_width              =  14.64;       // 7.32
const float_type    goal_depth              =   2.44;

const float_type    pitch_hlength   = pitch_length / 2;
const float_type    pitch_hwidth    = pitch_width / 2;
const float_type    penalty_hwidth  = penalty_area_width / 2;
const float_type    penalty_lstart  = penalty_area_length - pitch_hlength;
const float_type    penalty_rstart  = pitch_hlength - penalty_area_length;
const float_type    goal_hwidth     = goal_width / 2;
const float_type    Xmin            = - pitch_hlength - pitch_margin;
const float_type    Xmax            = pitch_hlength + pitch_margin;
const float_type    Ymin            = - pitch_hwidth - pitch_margin;
const float_type    Ymax            = pitch_hwidth + pitch_margin;

const int_type max_balls               = 1;
*/

const int_type max_teamplayers         = 11;
const int_type max_players             = max_teamplayers + max_teamplayers;

/*
const position  field           = { 0, 0, pitch_length, pitch_width }; 
const position  goals[]  = {{ -pitch_hlength, 0, 0, goal_width },
                                   { pitch_hlength, 0, 0, goal_width }};
#define max_goals (sizeof(::goals)/sizeof(::goals[0]))
const position  flags[]  =
      {{ -pitch_hlength, -pitch_hwidth, 0, 0 },         // id_flag_l_t
       { -pitch_hlength, pitch_hwidth, 0, 0 },          // id_flag_l_b
       { 0, -pitch_hwidth, 0, 0 },                      // id_flag_c_t
       { 0, pitch_hwidth, 0, 0 },                       // id_flag_c_b 
       { pitch_hlength, -pitch_hwidth, 0, 0 },          // id_flag_r_t
       { pitch_hlength, pitch_hwidth, 0, 0 },           // id_flag_r_b
       { penalty_lstart, -penalty_hwidth, 0, 0 },       // id_pflag_l_t
       { penalty_lstart, 0, 0, 0 },                     // id_pflag_l_c
       { penalty_lstart, penalty_hwidth, 0, 0 },        // id_pflag_l_b
       { penalty_rstart, -penalty_hwidth, 0, 0 },       // id_pflag_r_t
       { penalty_rstart, 0, 0, 0 },                     // id_pflag_r_c
       { penalty_rstart, penalty_hwidth, 0, 0 },        // id_pflag_r_b
       { 0, 0, 0, 0 },                                  // id_flag_c
       { -pitch_hlength, -goal_hwidth, 0, 0 },          // id_gflag_l_t
       { -pitch_hlength, goal_hwidth, 0, 0 },           // id_gflag_l_b
       { pitch_hlength, -goal_hwidth, 0, 0 },           // id_gflag_r_t
       { pitch_hlength, goal_hwidth, 0, 0 },            // id_gflag_r_b
       { -10, -pitch_hwidth - pitch_margin, 0, 0 },     // id_oflag_t_l_10
       { -20, -pitch_hwidth - pitch_margin, 0, 0 },     // id_oflag_t_l_20
       { -30, -pitch_hwidth - pitch_margin, 0, 0 },     // id_oflag_t_l_30
       { -40, -pitch_hwidth - pitch_margin, 0, 0 },     // id_oflag_t_l_40
       { -50, -pitch_hwidth - pitch_margin, 0, 0 },     // id_oflag_t_l_50
       { 10, -pitch_hwidth - pitch_margin, 0, 0 },      // id_oflag_t_r_10
       { 20, -pitch_hwidth - pitch_margin, 0, 0 },      // id_oflag_t_r_20
       { 30, -pitch_hwidth - pitch_margin, 0, 0 },      // id_oflag_t_r_30
       { 40, -pitch_hwidth - pitch_margin, 0, 0 },      // id_oflag_t_r_40
       { 50, -pitch_hwidth - pitch_margin, 0, 0 },      // id_oflag_t_r_50
       { -10, pitch_hwidth + pitch_margin, 0, 0 },      // id_oflag_b_l_10
       { -20, pitch_hwidth + pitch_margin, 0, 0 },      // id_oflag_b_l_20
       { -30, pitch_hwidth + pitch_margin, 0, 0 },      // id_oflag_b_l_30
       { -40, pitch_hwidth + pitch_margin, 0, 0 },      // id_oflag_b_l_40
       { -50, pitch_hwidth + pitch_margin, 0, 0 },      // id_oflag_b_l_50
       { 10, pitch_hwidth + pitch_margin, 0, 0 },       // id_oflag_b_r_10
       { 20, pitch_hwidth + pitch_margin, 0, 0 },       // id_oflag_b_r_20
       { 30, pitch_hwidth + pitch_margin, 0, 0 },       // id_oflag_b_r_30
       { 40, pitch_hwidth + pitch_margin, 0, 0 },       // id_oflag_b_r_40
       { 50, pitch_hwidth + pitch_margin, 0, 0 },       // id_oflag_b_r_50
       { -pitch_hlength - pitch_margin, -10, 0, 0 },    // id_oflag_l_t_10
       { -pitch_hlength - pitch_margin, -20, 0, 0 },    // id_oflag_l_t_20
       { -pitch_hlength - pitch_margin, -30, 0, 0 },    // id_oflag_l_t_30
       { -pitch_hlength - pitch_margin, 10, 0, 0 },     // id_oflag_l_b_10
       { -pitch_hlength - pitch_margin, 20, 0, 0 },     // id_oflag_l_b_20
       { -pitch_hlength - pitch_margin, 30, 0, 0 },     // id_oflag_l_b_30
       { pitch_hlength + pitch_margin, -10, 0, 0 },     // id_oflag_r_t_10
       { pitch_hlength + pitch_margin, -20, 0, 0 },     // id_oflag_r_t_20
       { pitch_hlength + pitch_margin, -30, 0, 0 },     // id_oflag_r_t_30
       { pitch_hlength + pitch_margin, 10, 0, 0 },      // id_oflag_r_b_10
       { pitch_hlength + pitch_margin, 20, 0, 0 },      // id_oflag_r_b_20
       { pitch_hlength + pitch_margin, 30, 0, 0 },      // id_oflag_r_b_30
       { 0, -pitch_hwidth - pitch_margin, 0, 0 },       // id_oflag_t_0
       { 0, pitch_hwidth + pitch_margin, 0, 0 },        // id_oflag_b_0
       { -pitch_hlength - pitch_margin, 0, 0, 0 },      // id_oflag_l_0
       { pitch_hlength + pitch_margin, 0, 0, 0 }};      // id_oflag_r_0
#define max_flags (sizeof(::flags)/sizeof(::flags[0]))

const position lines[]   = {{ -pitch_hlength, 0, 0, pitch_width },
                                   { pitch_hlength, 0, 0, pitch_width },
                                   { 0, -pitch_hwidth, pitch_length, 0 },
                                   { 0, pitch_hwidth, pitch_length, 0 }};
#define max_lines (sizeof(::lines)/sizeof(::lines[0]))


inline position pos_convert(char side, position p) 
{
        if (side != right_side) return p;
        else
	  {
	    position converted = {-p.x, -p.y, p.xsize, p.ysize};
	    return converted;
	  }
}
*/

#endif
